<?php
require_once(SITEBILL_DOCUMENT_ROOT.'/third/smarty/Smarty.class.php');
$smarty = new Smarty;
$smarty->template_dir = SITEBILL_DOCUMENT_ROOT.'/apps/admin/admin/template';
$smarty->cache_dir    = SITEBILL_DOCUMENT_ROOT.'/cache/smarty';
$smarty->compile_dir  = SITEBILL_DOCUMENT_ROOT.'/cache/compile';

$smarty->assign('ADMIN_BASE', SITEBILL_ADMIN_BASE);
$smarty->assign('MAIN_URL', SITEBILL_MAIN_URL);
$smarty->assign('estate_folder', SITEBILL_MAIN_URL);
$smarty->assign('estate_folder_control', SITEBILL_MAIN_URL.'/admin/');

//require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/multilanguage/multilanguage.class.php';
//	    $ML=Multilanguage::getInstance('backend','en');
//$ML::text('L_LAST_FIRST_MIDDLE');
//	    $ML::assign($smarty);

require_once(SITEBILL_DOCUMENT_ROOT."/inc/db.inc.php");

require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/db/MySQL.php');

require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/multilanguage/multilanguage.class.php';

//Multilanguage::start('backend','en');
if(isset($_GET['_lang'])){
	$_SESSION['_lang']=$_GET['_lang'];
}
Multilanguage::start('backend',$_SESSION['_lang']);

require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/login.inc.php');
if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/sitebill_registry.php') ) {
	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/sitebill_registry.php');
}

$sitebill = new SiteBill();

function appendAppToRecently(){
	//echo $_REQUEST['action'];
	if(!isset($_SESSION['_apps_memory']['list'])){
		require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/apps/apps_processor.php');
		$apps_processor = new Apps_Processor();
		$_SESSION['_apps_memory']['list']=$apps_processor->load_apps_menu();
	}
	
	if($_REQUEST['action'] != '' && $_REQUEST['action'] != 'data'){
		if(isset($_SESSION['_apps_memory']['list'][$_REQUEST['action']])){
			$app_name='<a href="'.SITEBILL_MAIN_URL.'/admin/?action='.$_REQUEST['action'].'">'.$_SESSION['_apps_memory']['list'][$_REQUEST['action']]['title'].'</a>';
		}else{
			$app_name='<a href="'.SITEBILL_MAIN_URL.'/admin/?action='.$_REQUEST['action'].'">'.Multilanguage::_('L_APPLICATION').' "'.$_REQUEST['action'].'"</a>';
		}
	}else{
		//$app_name=' ';
		$app_name='';
	}
	if($app_name!='' && $_SESSION['recently_apps'][0]!=$app_name){
		if(!isset($_SESSION['recently_apps'])){
			$_SESSION['recently_apps'][]=$app_name;
		}else{
			array_unshift($_SESSION['recently_apps'],$app_name);
		}
		
	}
}

$smarty->assign('show_admin_helper', $sitebill->getConfigValue('show_admin_helper'));

appendAppToRecently();




if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/index.php') ) {
	include_once(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/index.php');
} else {
	//$sitebill_document_root = $_SERVER['DOCUMENT_ROOT'];

	
	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php');
	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_admin.php');
	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/sitebill_krascap_editor.php');
	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');

	$sitebill_rent_editor = new SiteBill_Rent_Editor();
	$admin_menu = $sitebill_rent_editor->getAdminMenu();
	$smarty->assign('admin_menu', $admin_menu);
	
	$am_array=$sitebill_rent_editor->getAdminMenuArray();
	$smarty->assign('admin_menua', $am_array);

	if ( $sitebill->getConfigValue('check_permissions') ) {
		require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/permission/permission.php');
		$permission = new Permission();
		$action = $sitebill->getRequestValue('action');
		if ( $action == '' ) {
			$action = 'data';
		}
		if ( !$permission->get_access($_SESSION['user_id_value'], $action, 'access') ) {
			//echo 'access deny '.$menu_key.'<br>';
			$smarty->assign('content', ' ');
			$smarty->display("main.tpl");
			exit;
			//continue;
		}
	
	}
	
	if ( $_REQUEST['action'] != ''  ) {
		if ( $_REQUEST['action'] == 'street' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/street/street_manager.php');
			$Street_Manager = new Street_Manager();
			$rs = $Street_Manager->main();
		} elseif( $_REQUEST['action'] == 'menu' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/menu/menu_manager.php');
			$Menu_Manager = new Menu_Manager();
			$rs = $Menu_Manager->main();
		} elseif( $_REQUEST['action'] == 'country' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/country/country_manager.php');
			$Country_Manager = new Country_Manager();
			$rs = $Country_Manager->main();
		} elseif( $_REQUEST['action'] == 'data' ) {
			if ( $sitebill->getConfigValue('apps.realtypro.enable') ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/apps/realtypro/admin/admin.php');
				$realty_pro_admin = new realtypro_admin();
				$rs = $realty_pro_admin->main();
			} else {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
				if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php') ) {
					require_once (SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php');
					$data_manager_local = new Data_Manager_Local();
					$rs = $data_manager_local->main();
				} else {
					$Data_Manager = new Data_Manager();
					$rs = $Data_Manager->main();
				}
			}
		} elseif( $_REQUEST['action'] == 'group' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/group/group_manager.php');
			$Group_Manager = new Group_Manager();
			$rs = $Group_Manager->main();
		} elseif( $_REQUEST['action'] == 'function' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/function/function_manager.php');
			$Function_Manager = new Function_Manager();
			$rs = $Function_Manager->main();
		} elseif( $_REQUEST['action'] == 'component' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/component/component_manager.php');
			$Component_Manager = new Component_Manager();
			$rs = $Component_Manager->main();
		} elseif( $_REQUEST['action'] == 'region' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/region/region_manager.php');
			$Region_Manager = new Region_Manager();
			$rs = $Region_Manager->main();
		} elseif( $_REQUEST['action'] == 'city' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/city/city_manager.php');
			$City_Manager = new City_Manager();
			$rs = $City_Manager->main();
		} elseif( $_REQUEST['action'] == 'metro' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/metro/metro_manager.php');
			$Metro_Manager = new Metro_Manager();
			$rs = $Metro_Manager->main();
		} elseif( $_REQUEST['action'] == 'district' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/district/district_manager.php');
			$District_Manager = new District_Manager();
			$rs = $District_Manager->main();
		} elseif( $_REQUEST['action'] == 'structure' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
			$Structure_Manager = new Structure_Manager();
			$rs = $Structure_Manager->main();
		} elseif( $_REQUEST['action'] == 'structure_company' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php');
			$Structure_Manager = Structure_Implements::getManager('company');
			$rs = $Structure_Manager->main();
		} elseif( $_REQUEST['action'] == 'structure_booking_hotel' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_implements.php');
			$Structure_Manager = Structure_Implements::getManager('booking_hotel');
			$rs = $Structure_Manager->main();
		} elseif( $_REQUEST['action'] == 'rent_order' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/components/com_data_get_rent/sitebill_data_get_rent.php');
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/rent_order/rent_order.php');
			$rent_order = new Rent_Order();
			$rs = $rent_order->main();
		}elseif( $_REQUEST['action'] == 'user' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
			$Users_Manager = new User_Object_Manager();
			$rs = $Users_Manager->main();
		} elseif( $_REQUEST['action'] == 'category' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/shop_category/shop_category_manager.php');
			$Shop_Category_Manager = new Shop_Category_Manager();
			$rs = $Shop_Category_Manager->main();
		} elseif( $_REQUEST['action'] == 'product' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/shop/lib/shop_product/shop_product_manager.php');
			$Shop_Product_Manager = new Shop_Product_Manager();
			$rs = $Shop_Product_Manager->main();
		} elseif( $_REQUEST['action'] == 'shop_order' ) {
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/shop/lib/shop_order/shop_order_manager.php');
			$Shop_Order_Manager = new Shop_Order_Manager();
			$rs = $Shop_Order_Manager->main();
		} elseif( $_REQUEST['action'] == 'logout' ) {
			$sitebill->delete_session_key($_SESSION['session_key']);
			unset($_SESSION['user_id']);
			unset($_SESSION['user_id_value']);
			unset($_SESSION['group']);
			unset($_SESSION['session_key']);
			unset($_SESSION['key']);
			header('Location: '.SITEBILL_ADMIN_BASE);
			exit;
		} else {
			//try run apps
			try {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/apps/apps_processor.php');
				$apps_processor = new Apps_Processor();
				$rs = $apps_processor->run($_REQUEST['action'], 'admin');
			} catch ( Exception $e ) {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
				if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php') ) {
					require_once (SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php');
					$data_manager_local = new Data_Manager_Local();
					$rs = $data_manager_local->main();
				} else {
					$Data_Manager = new Data_Manager();
					$rs = $Data_Manager->main();
				}
			}

		}
	} else {
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
		if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php') ) {
			require_once (SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/data/data_manager.php');
			$data_manager_local = new Data_Manager_Local();
			$rs = $data_manager_local->main();
		} else {
			$Data_Manager = new Data_Manager();
			$rs = $Data_Manager->main();
		}
	}
}
$smarty->assign('content', $rs);

//print_r($admin_menu);
if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/template/main.tpl') ) {
	$smarty->display(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme').'/admin/template/main.tpl');
} else {
	$smarty->display("main.tpl");
}
exit;
