{literal}
<style>
.form_element_html {
	/*width: 250px;*/
	float: left;
}

.form_element_title {
	width: 160px;
	float: left;
	clear: both;
    font-size: 14px;
    padding-top: 3px;	
}

.form_element_control {
	clear: both;
}

.form_element {
    padding: 5px;
	clear: both;
	float: left;
	width: 99%;
	background-color: #f7fff3;
	margin: 1px;
    -moz-border-radius: 3px;
    border-radius: 3px;	
}
.form_element:hover {
    background-color: #ccffcc;
}

.block {
	border: 1px solid silver;
	padding: 20px 20px 0 20px;
	width: 300px;
	margin: 10px;
	position: relative;
	float: left;
}

.innerdiv {
	float: left;
	margin-bottom: 15px;
}

.innerdiv select {
	width: 185px;
}

.left_side {
	width: 380px;
	float: left;
}

.right_side {
	width: 380px;
	float: left;
}

.block label {
	position: absolute;
	top: -8px;
	left: 10px;
	padding: 0 5px;
	background-color: white;
	font-weight: bold;
}

.block10 textarea {
	width: 290px;
	height: 143px;
}


</style>

<script type="text/javascript">
$(document).ready(function(){
	$("#formsubmit").click(function(){
		$(this).hide();
		$('<p class="loading"> ...</p>').insertAfter(this).slideDown("fast");
	});
});
</script>
{/literal}



<div class="tabbed_form_block">

{if $form_error ne ''}
	<p class="error">{$form_error}</p>
{/if}
<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script>
<!-- <script type="text/javascript" src="{$estate_folder}/apps/system/js/geodata.js"></script> -->

{$form_elements.form_header}


{foreach from=$form_elements.private key=tab item=p_element}
	{$p_element.html}
{/foreach}
<script type="text/javascript" src="{$estate_folder}/apps/system/js/form_tabs.js"></script>
<link rel="stylesheet" type="text/css" href="{$estate_folder}/apps/system/css/form_tabs.css" />

{if $form_elements.public|count eq 1}
        

	{foreach from=$form_elements.public key=tab item=tab_elements}
		{foreach from=$tab_elements item=element}
		<div class="form_element" alt="{$element.name}">
			<div class="form_element_title">{$element.title}
			{if $element.required eq 1}
				<span style="color: red;">*</span>
			{/if}
			</div>
			<div class="form_element_html">{$element.html}</div>
			{if $element.image_list ne ''}
				<div style="clear: both;"></div>
				<div>{$element.image_list}</div>
			{/if}
		</div>
		{/foreach}
	{/foreach}
{else}

	{if $divide_by_step==1}
		<!-- DIVIDED BY STEPS FORM -->
		<script type="text/javascript" src="{$estate_folder}/apps/system/js/form_tabs.js"></script>
		<link rel="stylesheet" type="text/css" href="{$estate_folder}/apps/system/css/form_tabs.css" />
		<link rel="stylesheet" type="text/css" href="{$estate_folder}/apps/system/css/form_tabs_divided.css" />
		
		<div id="form_tab_switcher" style="display:none;">
		{foreach name=tab_foreach from=$form_elements.public key=tab item=tab_elements}
			{assign var=tab_id value=md5($tab)}
			{if $smarty.foreach.tab_foreach.iteration>$current_step}
				<span>{$tab}</span>
			{elseif $smarty.foreach.tab_foreach.iteration==$current_step}
				<a href="{$tab_id}" class="active_tab">{$tab}</a>
			{else}
				<a href="{$tab_id}">{$tab}</a>
			{/if}
		{/foreach}
		</div>
		
		<div class="steps">
		{foreach name=tab_foreach from=$form_elements.public key=tab item=tab_elements}
			{assign var=tab_id value=md5($tab)}
			{if $smarty.foreach.tab_foreach.iteration>$current_step}
				<div class="future">{$tab}</div>
			{elseif $smarty.foreach.tab_foreach.iteration==$current_step}
				<div class="current"><a class="go_to_step" alt="{$smarty.foreach.tab_foreach.iteration}" href="/add/step{$smarty.foreach.tab_foreach.iteration}">{$tab}</a></div>
			{else}
				<div class="done"><a class="go_to_step" alt="{$smarty.foreach.tab_foreach.iteration}" href="/add/step{$smarty.foreach.tab_foreach.iteration}">{$tab}</a></div>
			{/if}
		{/foreach}
		</div>
		
		{foreach name=tab_foreach_els from=$form_elements.public key=tab item=tab_elements}
			{assign var=tab_id value=md5($tab)}
			{if $smarty.foreach.tab_foreach_els.iteration==$current_step}
			<div class="form_tab" id="{$tab_id}">
				<h1>{$tab}</h1>
				{foreach from=$tab_elements item=element}
					<div class="form_element" alt="{$element.name}">
						<div class="form_element_title">
							{$element.title}
							{if $element.required eq 1}
								<span style="color: red;">*</span>
							{/if}
						</div>
						<div class="form_element_html">{$element.html}</div>
						{if $element.image_list ne ''}
							<div style="clear: both;"></div>
							<div>{$element.image_list}</div>
						{/if}
					</div>
					{/foreach}
				</div>
			{else}
				<div class="form_tab">
					<h1>{$tab}</h1>
					{foreach from=$tab_elements item=element}
					<div class="form_element" alt="{$element.name}">
						<div class="form_element_title">
							{$element.title}
							{if $element.required eq 1}
								<span style="color: red;">*</span>
							{/if}
						</div>
						<div class="form_element_html">{$element.html}</div>
						{if $element.image_list ne ''}
							<div style="clear: both;"></div>
							<div>{$element.image_list}</div>
						{/if}
					</div>
					{/foreach}
				</div>
			{/if}
		{/foreach}
		
		
		
			
		
		
		<!-- .DIVIDED BY STEPS FORM -->
	{else}
		<!-- USUAL FORM WITH TABS -->
		<script type="text/javascript" src="{$estate_folder}/apps/system/js/form_tabs.js"></script>
		<link rel="stylesheet" type="text/css" href="{$estate_folder}/apps/system/css/form_tabs.css" />
		
		<div id="form_tab_switcher">
		{foreach from=$form_elements.public key=tab item=tab_elements}
			{assign var=tab_id value=md5($tab)}
			<a href="{$tab_id}">{$tab}</a>
		{/foreach}
		</div>
	
	
	
	
	
		{foreach from=$form_elements.public key=tab item=tab_elements}
			{assign var=tab_id value=md5($tab)}
			<div class="form_tab" id="{$tab_id}">
				<h1>{$tab}</h1>
				{foreach from=$tab_elements item=element}
				<div class="form_element" alt="{$element.name}">
					<div class="form_element_title">
						{$element.title}
						{if $element.required eq 1}
							<span style="color: red;">*</span>
						{/if}
					</div>
					<div class="form_element_html">{$element.html}</div>
					{if $element.image_list ne ''}
						<div style="clear: both;"></div>
						<div>{$element.image_list}</div>
					{/if}
				</div>
				{/foreach}
			</div>
		{/foreach}
		<!-- .USUAL FORM WITH TABS -->
	{/if}

	
{/if}


<div class="form_element_control">
{$form_elements.controls.apply.html} {$form_elements.controls.back.html} {$form_elements.controls.submit.html}
</div>

{$form_elements.form_footer}
</div>