<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Banner admin backend
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class banner_admin extends Object_Manager {
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
        $this->table_name = 'banner';
        $this->action = 'banner';
        $this->primary_key = 'banner_id';
	    
        $this->data_model = $this->get_banner_model();
        
        //$this->install();
    }
    
	function add_data ( $form_data ) {
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
	    $query = $data_model->get_insert_query(DB_PREFIX.'_'.$this->table_name, $form_data);
	    $this->db->exec($query);
	    $new_record_id = $this->db->last_insert_id();
	    /*
	    $imgs=$this->editImageMulti($this->table_name, $this->table_name, $this->primary_key, $new_record_id);
	    
		if($this->getConfigValue('is_watermark')){
			$filespath = SITEBILL_DOCUMENT_ROOT.'/img/data/';
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/watermark/watermark.php';
			$Watermark=new Watermark();
			$Watermark->setPosition('bottom-left');
			$Watermark->setOffsets(array(20,50));
			if(!empty($imgs)){
				foreach($imgs as $v){
					$Watermark->printWatermark($filespath.$v['normal']);
				}
			}
		}
		*/
	    return true;
	}
	
	function edit_data ( $form_data ) {
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $query = $data_model->get_edit_query(DB_PREFIX.'_'.$this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data);
	    //echo $query;
	    
	    $this->db->exec($query);
	    /*
	    $imgs=$this->editImageMulti($this->table_name, $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
	    
		if($this->getConfigValue('is_watermark')){
			$filespath = SITEBILL_DOCUMENT_ROOT.'/img/data/';
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/watermark/watermark.php';
			$Watermark=new Watermark();
			$Watermark->setPosition('bottom-left');
			$Watermark->setOffsets(array(20,50));
			if(!empty($imgs)){
				foreach($imgs as $v){
					$Watermark->printWatermark($filespath.$v['normal']);
				}
			}
		}
	    */
	}
    
    
    function install () {
        //create tables
        $query = "
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_banner` (
  `banner_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `body` text,
  `catalog_id` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `url` text NOT NULL,
  PRIMARY KEY (`banner_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." ;
        ";
        $this->db->exec($query);

    }
    
    /**
     * Grid
     * @param void
     * @return string
     */
    function grid () {
        global $_SESSION;
        global $__db_prefix;
        
        $query = "select * from ".DB_PREFIX."_".$this->table_name." order by ".$this->primary_key." asc";
        $this->db->exec($query);

        $rs = '<div align="left"><table border="0" width="20%">';
        $rs .= '<td ><b></b></td>';
        $rs .= '<td></td>';
        $rs .= '</tr>';
        while ( $this->db->fetch_assoc() ) {
            $j++;
            if ( ceil($j/2) > floor($j/2)  ) {
                $row_class = "row1";
            } else {
                $j = 0;
                $row_class = "row2";
            }
            $rs .= '<tr>';
            $rs .= '<td class="'.$row_class.'" nowrap width="99%">'.$this->db->row['title'].'</td>';
            $rs .= '<td width="10%" nowrap><a href="?action='.$this->action.'&do=edit&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'"><img src="'.SITEBILL_MAIN_URL.'/img/edit.gif" border="0"></a> <a href="?action='.$this->action.'&do=delete&'.$this->primary_key.'='.$this->db->row[$this->primary_key].'" onclick="if ( confirm(\''.Multilanguage::_('L_MESSAGE_REALLY_WANT_DELETE').'\') ) {return true;} else {return false;}"><img src="'.SITEBILL_MAIN_URL.'/img/delete.gif" border="0"></a></td>';
            $rs .= '</tr>';
        }
        $rs .= '</table></div>';
        return $rs;
    }
    
    
    /**
     * Get gallery model
     * @param
     * @return
     */
    function get_banner_model () {
		$form_banner = array();
		
		$form_banner['banner']['banner_id']['name'] = 'banner_id';
		$form_banner['banner']['banner_id']['title'] = Multilanguage::_('L_ID');
		$form_banner['banner']['banner_id']['value'] = 0;
		$form_banner['banner']['banner_id']['length'] = 40;
		$form_banner['banner']['banner_id']['type'] = 'primary_key';
		$form_banner['banner']['banner_id']['required'] = 'off';
		$form_banner['banner']['banner_id']['unique'] = 'off';
		
		$form_banner['banner']['title']['name'] = 'title';
		$form_banner['banner']['title']['title'] = Multilanguage::_('L_BANNER_MARK');
		$form_banner['banner']['title']['value'] = '';
		$form_banner['banner']['title']['length'] = 40;
		$form_banner['banner']['title']['type'] = 'safe_string';
		$form_banner['banner']['title']['required'] = 'on';
		$form_banner['banner']['title']['unique'] = 'off';
		
		$form_banner['banner']['body']['name'] = 'body';
		$form_banner['banner']['body']['title'] = Multilanguage::_('L_BANNER_BODY');
		$form_banner['banner']['body']['value'] = '';
		$form_banner['banner']['body']['length'] = 40;
		$form_banner['banner']['body']['type'] = 'textarea_editor';
		$form_banner['banner']['body']['required'] = 'on';
		$form_banner['banner']['body']['unique'] = 'off';
		$form_banner['banner']['body']['rows'] = '10';
		$form_banner['banner']['body']['cols'] = '60';
		
		$form_banner['banner']['published']['name'] = 'published';
		$form_banner['banner']['published']['title'] = Multilanguage::_('L_PUBLISHED');
		$form_banner['banner']['published']['value'] = '0';
		$form_banner['banner']['published']['type'] = 'checkbox';
		$form_banner['banner']['published']['required'] = 'off';
		$form_banner['banner']['published']['unique'] = 'off';
		/*
		
		$form_banner['banner']['url']['name'] = 'url';
		$form_banner['banner']['url']['title'] = Multilanguage::_('L_LINK');
		$form_banner['banner']['url']['value'] = '';
		$form_banner['banner']['url']['length'] = 40;
		$form_banner['banner']['url']['type'] = 'safe_string';
		$form_banner['banner']['url']['required'] = 'off';
		$form_banner['banner']['url']['unique'] = 'off';
		
		$form_banner['banner']['image']['name'] = 'image';
		$form_banner['banner']['image']['table_name'] = 'banner';
		$form_banner['banner']['image']['primary_key'] = 'id';
		$form_banner['banner']['image']['primary_key_value'] = 0;
		$form_banner['banner']['image']['action'] = 'banner';
		$form_banner['banner']['image']['title'] = '';
		$form_banner['banner']['image']['value'] = '';
		$form_banner['banner']['image']['length'] = 40;
		$form_banner['banner']['image']['type'] = 'uploadify_image';
		$form_banner['banner']['image']['required'] = 'off';
		$form_banner['banner']['image']['unique'] = 'off';
	*/		
		return $form_banner;
    }
}