<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Vendors admin backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class cache_admin extends Object_Manager {
	
	
	
    /**
     * Constructor
     */
    function __construct( $realty_type = false ) {
        $this->SiteBill();
        
        $this->table_name = 'cache';
        $this->action = 'cache';
        $this->primary_key = 'parameter';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/cache/admin/cache_model.php');
        $this->data_model_object=new Cache_Model();
		$this->data_model=$this->data_model_object->get_model();
		
        $this->install();
        //$this->check_config_structure();
    }
    
    /*
	function main(){
    	$rs.=parent::main();
    	require_once SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php';
    	$Config=new config_admin();
    	$x=$Config->getTabForm($Config->getConfigSection('apps.cache'));
		
    	$rs .= $x;
    	return $rs;
    }
    */
	/**
     * Main
     * @param void
     * @return string
     */
    function main () {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
	    
		$rs = $this->getTopMenu();

		switch( $this->getRequestValue('do') ){
			case 'delete' : {
		        $this->delete_data($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
			    if ( $this->getError() ) {
			        $rs .= '<div align="center">   : '.$this->GetErrorMessage().'<br>';
			        $rs .= '<a href="?action='.$this->action.'"></a>';
			        $rs .= '</div>';
			    } else {
		            $rs .= $this->grid();
			    }
		        break;
			}
			case 'clear' : {
				$this->clear_cache();
				$rs .= $this->grid($user_id);
				break;
			}
			
			
			default : {
			    $rs .= $this->grid($user_id);
			}
		}
		/*require_once SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php';
    	$Config=new config_admin();
    	$x=$Config->getTabForm($Config->getConfigSection('apps.cache'));
		
    	$rs .= $x;*/
		return $rs;
	}
    
    
    function clear_cache(){
    	$this->db->exec('TRUNCATE TABLE `'.DB_PREFIX.'_'.$this->table_name.'`');	
    }
    
	
    
    function install () {
        $query="CREATE TABLE IF NOT EXISTS `re_cache` (
  `parameter` varchar(200) NOT NULL,
  `value` longtext NOT NULL,
  `created_at` int(15) NOT NULL,
  `valid_for` int(15) NOT NULL,
  PRIMARY KEY (`parameter`)
) ENGINE=MyISAM DEFAULT CHARSET=".DB_ENCODING.";";

	$this->db->exec($query);
        
	}
	
	/**
	 * Delete data
	 * @param string $table_name
	 * @param string $primary_key
	 * @param int $primary_key_value
	 */
	function delete_data($table_name, $primary_key, $primary_key_value ) {
	    $query = "delete from ".DB_PREFIX."_".$table_name." where ".$primary_key." = '".$primary_key_value."'";
	    $this->db->exec($query);
	    if ( !$this->db->success ) {
	        $this->riseError($this->db->error);
	        return false;
	    }
	}
	
	
    
    /**
     * Grid
     * @param void
     * @return string
     */
    
    function grid () {
    	
    	$query='SELECT * FROM '.DB_PREFIX.'_'.$this->table_name.' ORDER BY '.$this->primary_key.' ASC';
    	$this->db->exec($query);
    	while($this->db->fetch_assoc()){
    		$params[]=$this->db->row;
    	}
    	
        if(count($params)>0){
        	$rs = '<table border="0" width="99%">';
	        $rs .= '<tr class="row_head">';
	        $rs .= '<td class="row_title">'.Multilanguage::_('L_PARAMETER').'</td>';
	        $rs .= '<td class="row_title">'.Multilanguage::_('L_CREATION_DATE').'</td>';
	        $rs .= '<td class="row_title">'.Multilanguage::_('L_VALID_DATE').'</td>';
	        $rs .= '</tr>';
        	
        	foreach($params as $p){
        		$rs .= '<tr class="row3">';
        		$rs .= '<td>'.$p['parameter'].'</td>';
        		$rs .= '<td>'.date('d-m-Y H:i:s',$p['created_at']).'</td>';
        		$rs .= '<td>'.date('d-m-Y H:i:s',$p['valid_for']).'</td>';
        		$rs .= '<td nowrap>';
	            $rs .= '<a href="?action='.$this->action.'&do=delete&'.$this->primary_key.'='.$p['parameter'].'" onclick="if ( confirm(\''.Multilanguage::_('L_MESSAGE_REALLY_WANT_DELETE').'\') ) {return true;} else {return false;}"><img src="'.SITEBILL_MAIN_URL.'/apps/admin/admin/template/img/delete.png" border="0" class="admin_control"></a>';
	            $rs .= '</td>';
	            $rs .= '</tr>';
        	}
        	$rs .= '</table>';
        	
        }else{
        	$rs.='<br><br>'.Multilanguage::_('L_NO_RECORDS');
        }
       
    	
    	/*$params=array();
    	$params['action']=$this->action;
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/grid.php');
        $common_grid = new Common_Grid($this);
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/page.php');
        $common_page = new Common_Page();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/tab.php');
    	$common_tab = new Common_Tab();
		$url='/admin/index.php?action='.$this->action;
		
    	$common_grid->add_grid_item('parameter');
    	$common_grid->add_grid_item('created_at');
       	$common_grid->add_grid_item('valid_for');
        
        //$common_grid->add_grid_control('edit');
        $common_grid->add_grid_control('delete');
		$common_grid->set_grid_query("SELECT * FROM ".DB_PREFIX."_".$this->table_name." ORDER BY ".$this->primary_key." ASC");
		//echo "SELECT * FROM ".DB_PREFIX."_".$this->table_name." ORDER BY ".$this->primary_key." ASC";
		$params['page']=$this->getRequestValue('page');
		$params['per_page']=$this->getConfigValue('common_per_page');
        
        $common_grid->setPagerParams($params);
        
        $common_page->setTab($common_tab);
        $common_page->setGrid($common_grid);
        //$rs='';
		$rs.=$common_page->toString();*/
		return $rs;
    }
    
	function getTopMenu(){
		$rs = '';
	    $rs .= '<a href="?action='.$this->action.'&do=clear" class="btn btn-primary">'.Multilanguage::_('L_CLEAR_CACHE').'</a>';
		//$rs .= '<form method="post"><input type="hidden" name="action" value="add" /><input type="submit" name="submit" value=" " /></form>';
	    return $rs;
	}
	
	
}