<?php
require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php';
class columns_Model extends Data_Model {
	
	public function __construct(){
		parent::__construct();
	}
	
	public function get_model(){
		$form_data = array();
		
		$form_data['columns']['columns_id']['name'] = 'columns_id';
		$form_data['columns']['columns_id']['title'] = 'ID';
		$form_data['columns']['columns_id']['value'] = 0;
		$form_data['columns']['columns_id']['type'] = 'primary_key';
		$form_data['columns']['columns_id']['required'] = 'off';
		$form_data['columns']['columns_id']['unique'] = 'off';
		
		$form_data['columns']['active']['name'] = 'active';
		$form_data['columns']['active']['title'] = ' ';
		$form_data['columns']['active']['value'] = 0;
		$form_data['columns']['active']['type'] = 'checkbox';
		$form_data['columns']['active']['required'] = 'off';
		$form_data['columns']['active']['unique'] = 'off';

		$form_data['columns']['sort_order']['name'] = 'sort_order';
		$form_data['columns']['sort_order']['title'] = ' ';
		$form_data['columns']['sort_order']['value'] = 0;
		$form_data['columns']['sort_order']['type'] = 'hidden';
		$form_data['columns']['sort_order']['required'] = 'off';
		$form_data['columns']['sort_order']['unique'] = 'off';
		
		$form_data['columns']['table_id']['name'] = 'table_id';
		$form_data['columns']['table_id']['primary_key_name'] = 'table_id';
		$form_data['columns']['table_id']['primary_key_table'] = 'name';
		$form_data['columns']['table_id']['title'] = '';
		$form_data['columns']['table_id']['value_string'] = '';
		$form_data['columns']['table_id']['value'] = 0;
		$form_data['columns']['table_id']['length'] = 40;
		$form_data['columns']['table_id']['type'] = 'select_by_query';
		$form_data['columns']['table_id']['query'] = 'select * from '.DB_PREFIX.'_table order by name';
		$form_data['columns']['table_id']['value_name'] = 'name';
		$form_data['columns']['table_id']['title_default'] = ' ';
		$form_data['columns']['table_id']['value_default'] = 0;
		$form_data['columns']['table_id']['required'] = 'on';
		$form_data['columns']['table_id']['unique'] = 'off';
		
		$form_data['columns']['type']['name'] = 'type';
		$form_data['columns']['type']['title'] = ' ';
		$form_data['columns']['type']['value'] = '';
		$form_data['columns']['type']['type'] = 'select_box';
		$form_data['columns']['type']['select_data'] = array('primary_key' => 'primary_key', 'safe_string' => 'safe_string', 'hidden' => 'hidden', 'checkbox' => 'checkbox', 'select_box_structure' => 'select_box_structure', 'select_by_query' => 'select_by_query', 'select_box' => 'select_box', 'auto_add_value' => 'auto_add_value', 'price' => 'price', 'textarea' => 'textarea', 'uploadify_image' => 'uploadify_image', 'mobilephone' => 'mobilephone', 'password' => 'password', 'photo' => 'photo', 'geodata' => 'geodata', 'structure' => 'structure', 'textarea_editor' => 'textarea_editor', 'date'=>'date', 'attachment'=>'attachment');
		$form_data['columns']['type']['required'] = 'off';
		$form_data['columns']['type']['unique'] = 'off';
		
		$form_data['columns']['group_id']['name'] = 'group_id';
		$form_data['columns']['group_id']['primary_key_name'] = 'group_id';
		$form_data['columns']['group_id']['primary_key_table'] = 'name';
		$form_data['columns']['group_id']['title'] = '   (-  )';
		$form_data['columns']['group_id']['value_string'] = '';
		$form_data['columns']['group_id']['value'] = 0;
		$form_data['columns']['group_id']['length'] = 40;
		$form_data['columns']['group_id']['type'] = 'select_by_query_multiple';
		$form_data['columns']['group_id']['query'] = 'select * from '.DB_PREFIX.'_group order by name';
		$form_data['columns']['group_id']['value_name'] = 'name';
		$form_data['columns']['group_id']['title_default'] = ' ';
		$form_data['columns']['group_id']['value_default'] = 0;
		$form_data['columns']['group_id']['required'] = 'off';
		$form_data['columns']['group_id']['unique'] = 'off';
		
		
		$form_data['columns']['active_in_topic']['name'] = 'active_in_topic';
		$form_data['columns']['active_in_topic']['title'] = '   (-  )';
		$form_data['columns']['active_in_topic']['value_string'] = '';
		$form_data['columns']['active_in_topic']['value'] = 0;
		$form_data['columns']['active_in_topic']['length'] = 40;
		$form_data['columns']['active_in_topic']['type'] = 'select_box_structure_simple_multiple';
		$form_data['columns']['active_in_topic']['required'] = 'off';
		$form_data['columns']['active_in_topic']['unique'] = 'off';
		
		
		
		
		$form_data['columns']['name']['name'] = 'name';
		$form_data['columns']['name']['title'] = '  (  )';
		$form_data['columns']['name']['value'] = '';
		$form_data['columns']['name']['type'] = 'safe_string';
		$form_data['columns']['name']['required'] = 'on';
		$form_data['columns']['name']['unique'] = 'off';
		
		$form_data['columns']['title']['name'] = 'title';
		$form_data['columns']['title']['title'] = '  ( )';
		$form_data['columns']['title']['value'] = '';
		$form_data['columns']['title']['type'] = 'safe_string';
		$form_data['columns']['title']['required'] = 'on';
		$form_data['columns']['title']['unique'] = 'off';
		
		$form_data['columns']['hint']['name'] = 'hint';
		$form_data['columns']['hint']['title'] = ' ( )';
		$form_data['columns']['hint']['value'] = '';
		$form_data['columns']['hint']['type'] = 'safe_string';
		$form_data['columns']['hint']['required'] = 'off';
		$form_data['columns']['hint']['unique'] = 'off';
		
		$form_data['columns']['value']['name'] = 'value';
		$form_data['columns']['value']['title'] = ' -';
		$form_data['columns']['value']['value'] = '';
		$form_data['columns']['value']['type'] = 'safe_string';
		$form_data['columns']['value']['required'] = 'off';
		$form_data['columns']['value']['unique'] = 'off';
		
		
		
		/*$form_data['columns']['primary_key_table']['name'] = 'primary_key_table';
		$form_data['columns']['primary_key_table']['title'] = '       ';
		$form_data['columns']['primary_key_table']['value'] = '';
		$form_data['columns']['primary_key_table']['type'] = 'safe_string';
		$form_data['columns']['primary_key_table']['required'] = 'off';
		$form_data['columns']['primary_key_table']['unique'] = 'off';*/
		
		$form_data['columns']['primary_key_table']['name'] = 'primary_key_table';
		$form_data['columns']['primary_key_table']['title'] = '       ';
		$form_data['columns']['primary_key_table']['value'] = '';
		$form_data['columns']['primary_key_table']['type'] = 'select_box';
		$form_data['columns']['primary_key_table']['select_data'] = array();
		$form_data['columns']['primary_key_table']['required'] = 'off';
		$form_data['columns']['primary_key_table']['unique'] = 'off';
		
		/*$form_data['columns']['primary_key_name']['name'] = 'primary_key_name';
		$form_data['columns']['primary_key_name']['title'] = '     ';
		$form_data['columns']['primary_key_name']['value'] = '';
		$form_data['columns']['primary_key_name']['type'] = 'safe_string';
		$form_data['columns']['primary_key_name']['required'] = 'off';
		$form_data['columns']['primary_key_name']['unique'] = 'off';*/
		
		$form_data['columns']['primary_key_name']['name'] = 'primary_key_name';
		$form_data['columns']['primary_key_name']['title'] = '     ';
		$form_data['columns']['primary_key_name']['value'] = '';
		$form_data['columns']['primary_key_name']['type'] = 'select_box';
		$form_data['columns']['primary_key_name']['select_data'] = array();
		$form_data['columns']['primary_key_name']['required'] = 'off';
		$form_data['columns']['primary_key_name']['unique'] = 'off';
		
		
		/*$form_data['columns']['value_name']['name'] = 'value_name';
		$form_data['columns']['value_name']['title'] = '   select_box';
		$form_data['columns']['value_name']['value'] = '';
		$form_data['columns']['value_name']['type'] = 'safe_string';
		$form_data['columns']['value_name']['required'] = 'off';
		$form_data['columns']['value_name']['unique'] = 'off';*/
		
		$form_data['columns']['value_name']['name'] = 'value_name';
		$form_data['columns']['value_name']['title'] = '   select_box';
		$form_data['columns']['value_name']['value'] = '';
		$form_data['columns']['value_name']['type'] = 'select_box';
		$form_data['columns']['value_name']['select_data'] = array();
		$form_data['columns']['value_name']['required'] = 'off';
		$form_data['columns']['value_name']['unique'] = 'off';

		/*$form_data['columns']['value_string']['name'] = 'value_string';
		$form_data['columns']['value_string']['title'] = '     select';
		$form_data['columns']['value_string']['value'] = '';
		$form_data['columns']['value_string']['type'] = 'safe_string';
		$form_data['columns']['value_string']['required'] = 'off';
		$form_data['columns']['value_string']['unique'] = 'off';*/
		
		$form_data['columns']['query']['name'] = 'query';
		$form_data['columns']['query']['title'] = 'SQL-       ';
		$form_data['columns']['query']['value'] = '';
		$form_data['columns']['query']['type'] = 'safe_string';
		$form_data['columns']['query']['required'] = 'off';
		$form_data['columns']['query']['unique'] = 'off';
		
		
		
		$form_data['columns']['title_default']['name'] = 'title_default';
		$form_data['columns']['title_default']['title'] = '   select_box -';
		$form_data['columns']['title_default']['value'] = '';
		$form_data['columns']['title_default']['type'] = 'safe_string';
		$form_data['columns']['title_default']['required'] = 'off';
		$form_data['columns']['title_default']['unique'] = 'off';

		$form_data['columns']['value_default']['name'] = 'value_default';
		$form_data['columns']['value_default']['title'] = '   select_box -';
		$form_data['columns']['value_default']['value'] = '';
		$form_data['columns']['value_default']['type'] = 'safe_string';
		$form_data['columns']['value_default']['required'] = 'off';
		$form_data['columns']['value_default']['unique'] = 'off';
		
		$form_data['columns']['value_table']['name'] = 'value_table';
		$form_data['columns']['value_table']['title'] = 'value_table';
		$form_data['columns']['value_table']['value'] = '';
		$form_data['columns']['value_table']['type'] = 'safe_string';
		$form_data['columns']['value_table']['required'] = 'off';
		$form_data['columns']['value_table']['unique'] = 'off';
		
		$form_data['columns']['value_primary_key']['name'] = 'value_primary_key';
		$form_data['columns']['value_primary_key']['title'] = 'value_primary_key';
		$form_data['columns']['value_primary_key']['value'] = '';
		$form_data['columns']['value_primary_key']['type'] = 'safe_string';
		$form_data['columns']['value_primary_key']['required'] = 'off';
		$form_data['columns']['value_primary_key']['unique'] = 'off';
		
		$form_data['columns']['value_field']['name'] = 'value_field';
		$form_data['columns']['value_field']['title'] = 'value_field';
		$form_data['columns']['value_field']['value'] = '';
		$form_data['columns']['value_field']['type'] = 'safe_string';
		$form_data['columns']['value_field']['required'] = 'off';
		$form_data['columns']['value_field']['unique'] = 'off';
		
		$form_data['columns']['assign_to']['name'] = 'assign_to';
		$form_data['columns']['assign_to']['title'] = 'assign_to';
		$form_data['columns']['assign_to']['value'] = '';
		$form_data['columns']['assign_to']['type'] = 'safe_string';
		$form_data['columns']['assign_to']['required'] = 'off';
		$form_data['columns']['assign_to']['unique'] = 'off';
		
		$form_data['columns']['dbtype']['name'] = 'dbtype';
		$form_data['columns']['dbtype']['title'] = 'SQL-  (\'notable\' - , \'\' - )';
		$form_data['columns']['dbtype']['value'] = '';
		$form_data['columns']['dbtype']['type'] = 'safe_string';
		$form_data['columns']['dbtype']['required'] = 'off';
		$form_data['columns']['dbtype']['unique'] = 'off';
		
		$form_data['columns']['dbtype']['name'] = 'dbtype';
		$form_data['columns']['dbtype']['title'] = '    ';
		$form_data['columns']['dbtype']['value'] = 1;
		$form_data['columns']['dbtype']['type'] = 'checkbox';
		$form_data['columns']['dbtype']['required'] = 'off';
		$form_data['columns']['dbtype']['unique'] = 'off';
		
		$form_data['columns']['select_data']['name'] = 'select_data';
		$form_data['columns']['select_data']['title'] = '      {key~~value}';
		$form_data['columns']['select_data']['value'] = '';
		$form_data['columns']['select_data']['type'] = 'safe_string';
		$form_data['columns']['select_data']['required'] = 'off';
		$form_data['columns']['select_data']['unique'] = 'off';
		
		$form_data['columns']['table_name']['name'] = 'table_name';
		$form_data['columns']['table_name']['title'] = 'Uploadify image:  ';
		$form_data['columns']['table_name']['value'] = '';
		$form_data['columns']['table_name']['type'] = 'safe_string';
		$form_data['columns']['table_name']['required'] = 'off';
		$form_data['columns']['table_name']['unique'] = 'off';
		
		$form_data['columns']['primary_key']['name'] = 'primary_key';
		$form_data['columns']['primary_key']['title'] = 'Uploadify image:        ';
		$form_data['columns']['primary_key']['value'] = '';
		$form_data['columns']['primary_key']['type'] = 'safe_string';
		$form_data['columns']['primary_key']['required'] = 'off';
		$form_data['columns']['primary_key']['unique'] = 'off';
		
		$form_data['columns']['primary_key_value']['name'] = 'primary_key_value';
		$form_data['columns']['primary_key_value']['title'] = 'Uploadify image:   ';
		$form_data['columns']['primary_key_value']['value'] = '';
		$form_data['columns']['primary_key_value']['type'] = 'safe_string';
		$form_data['columns']['primary_key_value']['required'] = 'off';
		$form_data['columns']['primary_key_value']['unique'] = 'off';
		
		$form_data['columns']['action']['name'] = 'action';
		$form_data['columns']['action']['title'] = 'Uploadify image:  action';
		$form_data['columns']['action']['value'] = '';
		$form_data['columns']['action']['type'] = 'safe_string';
		$form_data['columns']['action']['required'] = 'off';
		$form_data['columns']['action']['unique'] = 'off';
		
		$form_data['columns']['entity']['name'] = 'entity';
		$form_data['columns']['entity']['title'] = ' ';
		$form_data['columns']['entity']['value'] = '';
		$form_data['columns']['entity']['type'] = 'safe_string';
		$form_data['columns']['entity']['required'] = 'off';
		$form_data['columns']['entity']['unique'] = 'off';
		
		$form_data['columns']['combo']['name'] = 'combo';
		$form_data['columns']['combo']['title'] = ' -';
		$form_data['columns']['combo']['value'] = 0;
		$form_data['columns']['combo']['type'] = 'checkbox';
		$form_data['columns']['combo']['required'] = 'off';
		$form_data['columns']['combo']['unique'] = 'off';
		

		$form_data['columns']['required']['name'] = 'required';
		$form_data['columns']['required']['title'] = ' ';
		$form_data['columns']['required']['value'] = 0;
		$form_data['columns']['required']['type'] = 'checkbox';
		$form_data['columns']['required']['required'] = 'off';
		$form_data['columns']['required']['unique'] = 'off';

		$form_data['columns']['unique']['name'] = 'unique';
		$form_data['columns']['unique']['title'] = ' ';
		$form_data['columns']['unique']['value'] = 0;
		$form_data['columns']['unique']['type'] = 'checkbox';
		$form_data['columns']['unique']['required'] = 'off';
		$form_data['columns']['unique']['unique'] = 'off';
		
		$form_data['columns']['tab']['name'] = 'tab';
		$form_data['columns']['tab']['title'] = '   .   ,     -';
		$form_data['columns']['tab']['value'] = '';
		$form_data['columns']['tab']['type'] = 'safe_string';
		$form_data['columns']['tab']['required'] = 'off';
		$form_data['columns']['tab']['unique'] = 'off';
		
		
		return $form_data;
	}
}