<?php
require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php';
class News_Model extends Data_Model {
	
	public function __construct(){
		parent::__construct();
	}
	
	public function get_model(){
		$form_data = array();
		
		$form_data['news']['news_id']['name'] = 'news_id';
		$form_data['news']['news_id']['title'] = Multilanguage::_('L_ID');
		$form_data['news']['news_id']['value'] = 0;
		$form_data['news']['news_id']['length'] = 40;
		$form_data['news']['news_id']['type'] = 'primary_key';
		$form_data['news']['news_id']['required'] = 'off';
		$form_data['news']['news_id']['unique'] = 'off';
		
		$form_data['news']['title']['name'] = 'title';
		$form_data['news']['title']['title'] = Multilanguage::_('TITLE','news');
		$form_data['news']['title']['value'] = '';
		$form_data['news']['title']['length'] = 40;
		$form_data['news']['title']['type'] = 'safe_string';
		$form_data['news']['title']['required'] = 'on';
		$form_data['news']['title']['unique'] = 'off';
		
		$form_data['news']['anons']['name'] = 'anons';
		$form_data['news']['anons']['title'] = Multilanguage::_('ANONS','news');
		$form_data['news']['anons']['value'] = '';
		$form_data['news']['anons']['length'] = 40;
		$form_data['news']['anons']['type'] = 'textarea_editor';
		$form_data['news']['anons']['required'] = 'off';
		$form_data['news']['anons']['unique'] = 'off';
		$form_data['news']['anons']['rows'] = '10';
		$form_data['news']['anons']['cols'] = '40';
		
		$form_data['news']['description']['name'] = 'description';
		$form_data['news']['description']['title'] = Multilanguage::_('DESCRIPTION','news');
		$form_data['news']['description']['value'] = '';
		$form_data['news']['description']['length'] = 40;
		$form_data['news']['description']['type'] = 'textarea_editor';
		$form_data['news']['description']['required'] = 'off';
		$form_data['news']['description']['unique'] = 'off';
		$form_data['news']['description']['rows'] = '10';
		$form_data['news']['description']['cols'] = '40';
		
		$form_data['news']['date']['name'] = 'date';
		$form_data['news']['date']['title'] = Multilanguage::_('DATE','news');
		$form_data['news']['date']['value'] = time();
		$form_data['news']['date']['length'] = 40;
		$form_data['news']['date']['date_format'] = 'd.m.Y';
		$form_data['news']['date']['type'] = 'date';
		$form_data['news']['date']['required'] = 'on';
		$form_data['news']['date']['unique'] = 'off';
		
		$form_data['news']['image']['name'] = 'image';
		$form_data['news']['image']['table_name'] = 'news';
		$form_data['news']['image']['primary_key'] = 'news_id';
		$form_data['news']['image']['primary_key_value'] = 0;
		$form_data['news']['image']['action'] = 'news';
		$form_data['news']['image']['title'] = Multilanguage::_('L_UPLOADER_TITLE');
		$form_data['news']['image']['value'] = '';
		$form_data['news']['image']['length'] = 40;
		$form_data['news']['image']['type'] = 'uploadify_image';
		$form_data['news']['image']['required'] = 'off';
		$form_data['news']['image']['unique'] = 'off';
		
		return $form_data;
	}
}