<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
* Static pages handler backend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class page_admin extends Object_Manager {
	
	private $pages=array();
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
        Multilanguage::appendAppDictionary('page');
        $this->table_name = 'page';
        $this->action = 'page';
        $this->app_title = Multilanguage::_('APPLICATION_NAME','page');
        $this->primary_key = 'page_id';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/page/admin/page_model.php');
        $Object=new Page_Model();
		$this->data_model=$Object->get_model();
		
        //$this->install();
    }
    
    function upgrade () {
    	$query = "alter table ".DB_PREFIX."_page add column meta_title text";
    	$this->db->exec($query);
    }
    
    function main(){
    	$rs.=parent::main();
    	return $rs;
    }
    
    function getTopMenu(){
    	$rs = '';
	    $rs .= '<a href="?action='.$this->action.'&do=new" class="btn btn-primary">'.Multilanguage::_('ADD_PAGE','page').'</a>';
		return $rs;
    }
    
    function grid($user_id=NULL){
    	$this->upgrade();
    	$params=array();
    	$params['action']=$this->action;
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/grid.php');
        $common_grid = new Common_Grid($this);
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/page.php');
        $common_page = new Common_Page();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/tab.php');
    	$common_tab = new Common_Tab();
		$url='/admin/index.php?action='.$this->action;
		
    	$common_grid->add_grid_item('page_id');
    	$common_grid->add_grid_item('uri');
        $common_grid->add_grid_item('title');
        //$common_grid->add_grid_item('anons');
        
        $common_grid->add_grid_control('edit');
        $common_grid->add_grid_control('delete');
		$common_grid->set_grid_query("SELECT * FROM ".DB_PREFIX."_".$this->table_name." ORDER BY page_id DESC");
		$params['page']=$this->getRequestValue('page');
		$params['per_page']=$this->getConfigValue('common_per_page');
        
        $common_grid->setPagerParams($params);
        
        $common_page->setTab($common_tab);
        $common_page->setGrid($common_grid);
        //$rs='';
		$rs.=$common_page->toString();
		return $rs;
    }
    
 
    
    function install(){
    	$query="CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_".$this->table_name."` (
  `page_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `uri` varchar(255) NOT NULL DEFAULT '',
  `meta_keywords` text,
  `meta_description` text,
  `body` text,
  `date` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`page_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".DB_ENCODING." ;";
    	 $this->db->exec($query);
    }
    
   
}