<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * SEO admin backend
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class seo_admin extends Object_Manager {
    /**
     * Constructor
     */
    function __construct() {
        $this->action = 'seo';
        $this->app_title = 'SEO-';
        
        $this->SiteBill();
        
        require_once (SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php');
        $config_admin = new config_admin();
        
        if ( !$config_admin->check_config_item('apps.seo.html_prefix_enable') ) {
        	$config_admin->addParamToConfig('apps.seo.html_prefix_enable','1',' .html    URL ');
        }
         
        if ( !$config_admin->check_config_item('apps.seo.level_enable') ) {
        	$config_admin->addParamToConfig('apps.seo.level_enable','0',' SEO-   URL  .     ,    <a href="http://www.sitebill.ru/seo-level.html" target="_blank"></a>');
        }
        
        if ( !$config_admin->check_config_item('apps.seo.data_alias_enable') ) {
        	$config_admin->addParamToConfig('apps.seo.data_alias_enable','0',' SEO-    .');
        }
    }
    
	function main(){
	    if ( $this->getRequestValue('do') == 'update' ) {
            $rs = $this->update_structure();	        
	    } else {
	        $rs = '<a href="?action=seo&do=update">  </a>';
	    }
	    
	    $rs_new = $this->get_app_title_bar();
	    $rs_new .= $rs;
	     
    	return $rs_new;
    }
    
    function update_structure () {
        $query = "select * from ".DB_PREFIX."_topic";
        $this->db->exec($query);
        while ( $this->db->fetch_assoc() ) {
            $ra[] = $this->db->row;
        }
        if ( !is_array($ra) ) {
            return '  ';
        }
        foreach ( $ra as $item_id => $item ) {
            if ( empty($item['url']) ) {
                $url = $this->transliteMe($item['name']);
                $query = "update ".DB_PREFIX."_topic set url='$url' where id=".$item['id'];
                //echo $query.'<br>';
                $this->db->exec($query);
                if ( $this->db->success ) {
                    $rs .= ' '.$item['name']."  ,  SEO- = ".$url."<br>";
                } else {
                    $rs .= '    '.$item['name'].": ".$this->db->error."<br>";
                }
            }
        }
        if ( empty($rs) ) {
            $rs = ' URL  .     ,   URL  ,    URL';
        }
        return $rs;
    }
}