<?php
class Vk_Logger {
	
	private static $instance=NULL;
	private $config=array();
	/*
	private $config=array(
		'VK_APP_ID'             => '3056922', // ID 
		'VK_APP_SECRET'         => 'HuLDMvoK7wYO3GBFGZIe', //  
		'REDIRECT_URI'          => 'http://socialmedia2/e_realty/login/vk/',
		'DISPLAY'               => 'page', // page OR popup OR touch OR wap
		'SCOPE'                 => array(
				//'notify', //     .
				//'friends', //   . 
				//'photos', //   . 
				//'audio', //   . 
				//'video', //   .
				//'docs', //   .
				//'notes', //   . 
				//'pages', //   wiki-. 
				//'wall', //         . 
				//'groups', //    . 
				//'ads', //        API. 
				//'offline' //   API      . 
		), 
		'VK_URI_AUTH'           => 'http://oauth.vk.com/authorize?client_id={CLIENT_ID}&redirect_uri={REDIRECT_URI}&scope={SCOPE}&display={DISPLAY}',
		'VK_URI_ACCESS_TOKEN'   => 'https://oauth.vk.com/access_token?client_id={CLIENT_ID}&client_secret={APP_SECRET}&code={CODE}',
		'VK_URI_METHOD'         => 'https://api.vk.com/method/{METHOD_NAME}?{PARAMETERS}&access_token={ACCESS_TOKEN}'
		);
	*/
	public static function getInstance(){
		if(self::$instance==NULL){
			self::$instance=new Vk_Logger();
		}
		return self::$instance;
	}
	
	private function configure(){
		require_once (SITEBILL_DOCUMENT_ROOT.'/apps/config/admin/admin.php');
		$Config = new config_admin();
		
		$this->config=array(
		'VK_APP_ID'             => $Config->getConfigValue('apps.socialauth.vk.api_key'), // ID 
		'VK_APP_SECRET'         => $Config->getConfigValue('apps.socialauth.vk.secret'), //  
		'REDIRECT_URI'          => $Config->getConfigValue('apps.socialauth.vk.redirect_url'),
		'DISPLAY'               => 'popup', // page OR popup OR touch OR wap
		'SCOPE'                 => array(
				//'notify', //     .
				//'friends', //   . 
				//'photos', //   . 
				//'audio', //   . 
				//'video', //   .
				//'docs', //   .
				//'notes', //   . 
				//'pages', //   wiki-. 
				//'wall', //         . 
				//'groups', //    . 
				//'ads', //        API. 
				//'offline' //   API      . 
		), 
		'VK_URI_AUTH'           => 'http://oauth.vk.com/authorize?client_id={CLIENT_ID}&redirect_uri={REDIRECT_URI}&scope={SCOPE}&display={DISPLAY}',
		'VK_URI_ACCESS_TOKEN'   => 'https://oauth.vk.com/access_token?client_id={CLIENT_ID}&client_secret={APP_SECRET}&code={CODE}&redirect_uri={REDIRECT_URI}',
		'VK_URI_METHOD'         => 'https://api.vk.com/method/{METHOD_NAME}?{PARAMETERS}&access_token={ACCESS_TOKEN}'
		);
	}
	
	public function login(){
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/login.php');
		$login_object = new Login();
		
		$answer='';
		if(isset($_REQUEST['code'])){
			$code = $_REQUEST['code'];
		    $array = array(
				'{CLIENT_ID}'       => $this->config['VK_APP_ID'],
				'{APP_SECRET}'      => $this->config['VK_APP_SECRET'],
				'{CODE}'            => $code,
				'{REDIRECT_URI}'	=> $this->config['REDIRECT_URI']
			);
			
			//print_r($array);
		            
			$url = strtr($this->config['VK_URI_ACCESS_TOKEN'],$array);
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
			
			$json = curl_exec($ch);
			curl_close($ch);
		    $result = json_decode($json);
			
			//echo($json);
		         
			if(isset($result->error))
			{
				throw new Exception('  Access Token Error: '.$result->error.' , Description: '.$result->error_description);
			}else{                
				$sRequest = "https://api.vk.com/method/users.get?uids=".$result->user_id."&access_token=".$result->access_token."&fields=has_mobile";
				$ch = curl_init();
		
				curl_setopt($ch, CURLOPT_URL, $sRequest);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		
				$json = curl_exec($ch);
		
				curl_close($ch);
				//print_r($json);
				$oResponce = json_decode($json);
				
				if(isset($oResponce->error)){
					$answer='   .';
				}else{
					$result=$oResponce->response[0];
					$_login='vk'.$result->uid;
					$_pass='vk'.$result->uid;
					$email = $_login.'@vk.com'; 
					$_pass_md5=md5($_pass);
					if(!$login_object->checkLogin($_login, $_pass)){
						$now = (string) time();
						$user_verification_code = md5(uniqid().$now);
						$user_verification_time = $now+3600*24;
						$user_creation_date = date('Y-m-d H:i:s');
						
						$login_object->direct_add_user($_login, $_pass_md5, SiteBill::iconv('utf-8', SITE_ENCODING, $result->first_name.' '.$result->last_name), $email);
						//activate account
						$query = "update ".DB_PREFIX."_user set active=1 where login='{$_login}'";
						$login_object->db->exec($query);
						
						if(1==$login_object->getConfigValue('notify_admin_about_register')){
							require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
							$mailer = new Mailer();
							$message = '     '.$_login;
							$subject = '  '.$_login.'   '.$_SERVER['HTTP_HOST'];
							 
							$to = $login_object->getConfigValue('order_email_acceptor');
							$from = $login_object->getConfigValue('order_email_acceptor');
							if ( $login_object->getConfigValue('use_smtp') ) {
								$mailer->send_smtp($to, $from, $subject, $message, 1);
							} else {
								$mailer->send_simple($to, $from, $subject, $message, 1);
							}
						}
						
						$login_object->checkLogin($_login, $_pass);
					}
					header( 'HTTP/1.1 301 Moved Permanently' );
					header( 'Location: /' );
					die();
				}
			}
		        
		}else{
			$answer=$this->getLoginLink();
		}
		return $answer;
	}
	
	public function getLoginLink(){
		$array = array(
            '{CLIENT_ID}'       => $this->config['VK_APP_ID'],
            
            // add id of the restaurant in order to redirect to necessary page after login
            '{REDIRECT_URI}'    => $this->config['REDIRECT_URI'],
            '{SCOPE}'           => implode(',',$this->config['SCOPE']),
            '{DISPLAY}'         => $this->config['DISPLAY']
        );
        $href=strtr($this->config['VK_URI_AUTH'],$array);
		return '<a href="'.$href.'" class="vk_button"></a>';
	}
	
	public function getLoginURL(){
		$array = array(
				'{CLIENT_ID}'       => $this->config['VK_APP_ID'],
	
				// add id of the restaurant in order to redirect to necessary page after login
				'{REDIRECT_URI}'    => $this->config['REDIRECT_URI'],
				'{SCOPE}'           => implode(',',$this->config['SCOPE']),
				'{DISPLAY}'         => $this->config['DISPLAY']
		);
		$href=strtr($this->config['VK_URI_AUTH'],$array);
		return $href;
	}
	
	
	private function __construct(){
		$this->configure();
		if(isset($_SESSION['current_user']) && $_SESSION['current_user']['user_id']>0){
			$this->user_id=$_SESSION['current_user']['user_id'];
			$this->user_name=$_SESSION['current_user']['name'];
		}
	}
	
	
	
	private function __clone(){
		
	}
}