<?php
/**
 * Register using model
 * @author Kondin Dmitriy <kondin@etown.ru>
 */
class Register_Using_Model extends User_Object_Manager {
	function main () {
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		$form_data = $this->data_model;
		switch( $this->getRequestValue('do') ){
			case 'activate' : {
				$activation_code=$this->getRequestValue('activation_code');
				$email=$this->getRequestValue('email');
				$q="SELECT COUNT(*) AS cnt FROM ".DB_PREFIX."_user WHERE email='".$email."' AND pass='".$activation_code."' AND active=0";
				$this->db->exec($q);
				$this->db->fetch_assoc();
				if($this->db->row['cnt']!=0){
					$q="UPDATE ".DB_PREFIX."_user SET active=1 WHERE email='".$email."' AND pass='".$activation_code."'";
					$this->db->exec($q);
					$rs=Multilanguage::_('ACCOUNT_ACTIVATED','system');
					 
					if(1==$this->getConfigValue('registration_notice')){
						require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
						$mailer = new Mailer();
						if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/main/template/register_email_notify_complete.tpl.html') ) {
							global $smarty;
							 
							$q="SELECT * from ".DB_PREFIX."_user WHERE email='".$email."'";
							$this->db->exec($q);
							$this->db->fetch_assoc();
							
							$user_info = $this->db->row;
							//select password from cache
							$query = "select * from ".DB_PREFIX."_cache where parameter='{$activation_code}'";
							$this->db->exec($query);
							$this->db->fetch_assoc();
							$password = $this->db->row['value'];
							//remove password from cache
							$query = "delete from ".DB_PREFIX."_cache where parameter='{$activation_code}'";
							$this->db->exec($query);
						
							$smarty->assign('user_name', $user_info['fio']);
							$smarty->assign('site_url', 'http://'.$_SERVER['HTTP_HOST']);
							$smarty->assign('login', $user_info['login']);
							$smarty->assign('password', $password);
							$smarty->assign('email_signature', $this->getConfigValue('email_signature'));
						
							$message = $smarty->fetch(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/main/template/register_email_notify_complete.tpl.html');
						} else {
							$message = Multilanguage::_('NEW_REGISTER_BODY_TRIMMED','system');
						}
						
						$subject = sprintf(Multilanguage::_('NEW_REGISTER_TITLE','system'), $_SERVER['HTTP_HOST']);
						 
						$to = $this->getRequestValue('email');
						$from = $this->getConfigValue('order_email_acceptor');
						if ( $this->getConfigValue('use_smtp') ) {
							$mailer->send_smtp($to, $from, $subject, $message, 1);
						} else {
							$mailer->send_simple($to, $from, $subject, $message, 1);
						}
					}
					 
				}else{
					$rs=Multilanguage::_('ACTIVATION_ERROR','system');
				}
				return $rs;
			}
				
			case 'new_done' : {
				$form_data[$this->table_name]['newpass']['required'] = 'on';
				$form_data[$this->table_name]['newpass_retype']['required'] = 'on';
				
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				$form_data[$this->table_name]['group_id']['value'] = $this->getGroupIdByName('realtor');
				if ( isset($form_data[$this->table_name]['reg_date']) ) {
					$form_data[$this->table_name]['reg_date']['value'] = date('Y-m-d H:i:s');
				}
				
				 
				if ( !$this->check_data( $form_data[$this->table_name] ) ) {
					$form_data[$this->table_name]['imgfile']['value'] = '';
					$rs = $this->get_form($form_data[$this->table_name], 'new');
					 
				} else {
					$new_user_id = $this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
					if ( $this->getError() ) {
						$form_data[$this->table_name]['imgfile']['value'] = '';
						$rs = $this->get_form($form_data[$this->table_name], 'new');
					} else {
						$email = $form_data[$this->table_name]['email']['value'];
						$login = $form_data[$this->table_name]['login']['value'];
						$password = $form_data[$this->table_name]['newpass']['value'];
						
						if(1==$this->getConfigValue('use_registration_email_confirm')){
							$activation_code=md5(time().'_'.rand(100,999));
							$this->db->exec("UPDATE ".DB_PREFIX."_user SET pass='".$activation_code."' WHERE user_id=".$new_user_id);
							$activation_link='<a href="http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/register?do=activate&activation_code='.$activation_code.'&email='.$email.'">http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/register?do=activate&activation_code='.$activation_code.'&email='.$email.'</a>';
							require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
							$mailer = new Mailer();
							$message = sprintf(Multilanguage::_('NEW_REG_EMAILACCEPT_BODY','system'), $activation_link);
							$subject = sprintf(Multilanguage::_('NEW_REG_EMAILACCEPT_TITLE','system'), $_SERVER['HTTP_HOST']);
							 
							$to = $email;
							$from = $this->getConfigValue('order_email_acceptor');
							if ( $this->getConfigValue('use_smtp') ) {
								$mailer->send_smtp($to, $from, $subject, $message, 1);
							} else {
								$mailer->send_simple($to, $from, $subject, $message, 1);
							}
							
							//save tmp password
							$query = "delete from ".DB_PREFIX."_cache where parameter='{$activation_code}'";
							$this->db->exec($query);
							$query = "insert into ".DB_PREFIX."_cache (parameter, `value`) values ('$activation_code', '$password')";
							$this->db->exec($query);
							
							$rs = '<h3>'.Multilanguage::_('REGISTER_SUCCESS','system').'</h3><br>';
							$rs.=Multilanguage::_('ACTIVATION_CODE_SENT','system');
							return $rs;
						}
						
						if(1==$this->getConfigValue('registration_notice')){
							require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
							$mailer = new Mailer();
							$message = sprintf(Multilanguage::_('NEW_REGISTER_BODY','system'), $login, $password);
							$subject = sprintf(Multilanguage::_('NEW_REGISTER_TITLE','system'), $_SERVER['HTTP_HOST']);
							 
							$to = $email;
							$from = $this->getConfigValue('order_email_acceptor');
							if ( $this->getConfigValue('use_smtp') ) {
								$mailer->send_smtp($to, $from, $subject, $message, 1);
							} else {
								$mailer->send_simple($to, $from, $subject, $message, 1);
							}
						}
						
						$rs = $this->welcome();
					}
				}
				break;
			}
					
			default : {
				$form_data[$this->table_name]['newpass']['required'] = 'on';
				$form_data[$this->table_name]['newpass_retype']['required'] = 'on';
				$rs = $this->get_form($form_data[$this->table_name]);
			}
		}
		return $rs;
	}
	
	public function ajaxRegister(){
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		$form_data = $this->data_model;
		$form_data[$this->table_name]['newpass']['required'] = 'on';
		$form_data[$this->table_name]['newpass_retype']['required'] = 'on';
		
		$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
		$form_data[$this->table_name]['group_id']['value'] = $this->getGroupIdByName('realtor');
		if ( isset($form_data[$this->table_name]['reg_date']) ) {
			$form_data[$this->table_name]['reg_date']['value'] = date('Y-m-d H:i:s');
		}
		
		foreach ($form_data[$this->table_name] as $it=>$va){
			$form_data[$this->table_name][$it]['value']=SiteBill::iconv('utf-8', SITE_ENCODING, $va['value']);
		}
		
			
		if ( !$this->check_data( $form_data[$this->table_name] ) ) {
			$form_data[$this->table_name]['imgfile']['value'] = '';
			//$rs = $this->get_form($form_data[$this->table_name], 'new');
			return $this->getError();
		
		} else {
			$new_user_id = $this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
			if ( $this->getError() ) {
				$form_data[$this->table_name]['imgfile']['value'] = '';
				return $this->getError();
				$rs = $this->get_form($form_data[$this->table_name], 'new');
			} else {
				$email = $form_data[$this->table_name]['email']['value'];
				$login = $form_data[$this->table_name]['login']['value'];
				$password = $form_data[$this->table_name]['newpass']['value'];
		
				if(1==$this->getConfigValue('use_registration_email_confirm')){
					$activation_code=md5(time().'_'.rand(100,999));
					$this->db->exec("UPDATE ".DB_PREFIX."_user SET pass='".$activation_code."' WHERE user_id=".$new_user_id);
					$activation_link='<a href="http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/register?do=activate&activation_code='.$activation_code.'&email='.$email.'">http://'.$_SERVER['HTTP_HOST'].SITEBILL_MAIN_URL.'/register?do=activate&activation_code='.$activation_code.'&email='.$email.'</a>';
					require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
					$mailer = new Mailer();
					$message = sprintf(Multilanguage::_('NEW_REG_EMAILACCEPT_BODY','system'), $activation_link);
					$subject = sprintf(Multilanguage::_('NEW_REG_EMAILACCEPT_TITLE','system'), $_SERVER['HTTP_HOST']);
		
					$to = $email;
					$from = $this->getConfigValue('order_email_acceptor');
					if ( $this->getConfigValue('use_smtp') ) {
						$mailer->send_smtp($to, $from, $subject, $message, 1);
					} else {
						$mailer->send_simple($to, $from, $subject, $message, 1);
					}
						
					//save tmp password
					$query = "delete from ".DB_PREFIX."_cache where parameter='{$activation_code}'";
					$this->db->exec($query);
					$query = "insert into ".DB_PREFIX."_cache (parameter, `value`) values ('$activation_code', '$password')";
					$this->db->exec($query);
						
					$rs = '<h3>'.Multilanguage::_('REGISTER_SUCCESS','system').'</h3><br>';
					$rs.=Multilanguage::_('ACTIVATION_CODE_SENT','system');
					return $rs;
				}
		
				if(1==$this->getConfigValue('registration_notice')){
					require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
					$mailer = new Mailer();
					$message = sprintf(Multilanguage::_('NEW_REGISTER_BODY','system'), $login, $password);
					$subject = sprintf(Multilanguage::_('NEW_REGISTER_TITLE','system'), $_SERVER['HTTP_HOST']);
		
					$to = $email;
					$from = $this->getConfigValue('order_email_acceptor');
					if ( $this->getConfigValue('use_smtp') ) {
						$mailer->send_smtp($to, $from, $subject, $message, 1);
					} else {
						$mailer->send_simple($to, $from, $subject, $message, 1);
					}
				}
				return 'ok';
				$rs = $this->welcome();
			}
		}
	}
	
	public function getRegisterFormElements(){
		$form_data = $this->data_model;
		$form_data[$this->table_name]['newpass']['required'] = 'on';
		$form_data[$this->table_name]['newpass_retype']['required'] = 'on';
		
		$reg_form_elements=array();
		foreach($form_data[$this->table_name] as $fden=>$fdev){
			if($fdev['required']=='on'){
				$reg_form_elements[$fden]=$fdev;
			}
		}
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		$el = $form_generator->compile_form_elements($reg_form_elements,true);
		//echo '<pre>';
		//print_r($el);
		//$el[$this->getConfigValue('default_tab_name')]
		return $el['public'][$this->getConfigValue('default_tab_name')];
	}
	
	/**
	 * Check data
	 * @param array $form_data
	 * @return boolean
	 */
	function check_data ( $form_data ) {
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		 
		if ( $this->getRequestValue('do') != 'edit_done' ) {
			if ( !$this->checkEmail($form_data['email']['value']) ) {
				$this->riseError(' email  ');
				return false;
			}
		} else {
			if ( !$this->checkDiffEmail($form_data['email']['value'], $form_data['user_id']['value']) ) {
				$this->riseError(' email  ');
				return false;
			}
		}
		
		if(!preg_match('/^([a-zA-Z0-9-_]*)$/', $form_data['login']['value'])){
			$this->riseError('     , , , ');
			return false;
		}
		 
		if ( !$data_model->check_data($form_data) ) {
			$this->riseError($data_model->GetErrorMessage());
			return false;
		}
		 
		if ( $form_data['newpass']['value'] != '' ) {
			if ( strlen($form_data['newpass']['value']) < 5 ) {
				$this->riseError(sprintf(Multilanguage::_('MIN_PASSWORD_LENGTH','system'),'5'));
				return false;
			}
			if ( $form_data['newpass']['value'] != $form_data['newpass_retype']['value'] ) {
				$this->riseError(Multilanguage::_('PASSWORDS_NOT_EQUAL','system'));
				return false;
			}
		}
		 
		return true;
	}
	
	function welcome() {
		$rs = '<h3>'.Multilanguage::_('REGISTER_SUCCESS','system').'</h3><br>';
		$rs .= '<a href="'.SITEBILL_MAIN_URL.'/account/">'.Multilanguage::_('PRIVATE_ACCOUNT','system').'</a>';
		return $rs;
	}

	function get_user_model () {
		$form_data = array();
		$table_name='user';
		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/admin.php') && file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/columns/admin/admin.php') && file_exists(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/helper.php') ){
			require_once SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/helper.php';
			$ATH=new Admin_Table_Helper();
			$form_data=$ATH->load_model($table_name);
			if(empty($form_data)){
				$form_data = array();
				$form_data = $this->_get_user_model();
				require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php';
				require_once SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/admin.php';
				$TA=new table_admin();
				$TA->create_table_and_columns($form_data, $table_name);
				$form_data = array();
				$form_data=$ATH->load_model($table_name);
			}
		}else{
			$form_data = $this->_get_user_model($ajax);
		}
		$form_data['user']['group_id']['type'] = 'hidden';
		$form_data['user']['group_id']['value'] = $this->getGroupIdByName('realtor');
		unset($form_data['user']['company_id']);
		unset($form_data['user']['imgfile']);
		unset($form_data['user']['tariff_id']);
		
		$form_data['user']['captcha']['name'] = 'captcha';
		$form_data['user']['captcha']['title'] = ' ';
		$form_data['user']['captcha']['value'] = '';
		$form_data['user']['captcha']['length'] = 40;
		$form_data['user']['captcha']['type'] = 'captcha';
		$form_data['user']['captcha']['required'] = 'on';
		$form_data['user']['captcha']['dbtype'] = 'notable';
		$form_data['user']['captcha']['unique'] = 'off';
		
		return $form_data;
	}
	
}