<?php
class system_update extends SiteBill {
    /**
     * Construct
     */
    function __construct() {
        $this->sitebill();
    }
    
    function main () {
        $query_data[] = "alter table ".DB_PREFIX."_topic add column name_en varchar(255)";
        $query_data[] = "alter table ".DB_PREFIX."_data add column meta_title text";
        $query_data[] = "alter table ".DB_PREFIX."_data add column meta_keywords text";
        $query_data[] = "alter table ".DB_PREFIX."_data add column meta_description text";
        $query_data[] = "alter table ".DB_PREFIX."_data add column geo_lat decimal(9,6) DEFAULT NULL";
        $query_data[] = "alter table ".DB_PREFIX."_data add column geo_lng decimal(9,6) DEFAULT NULL";
        
        $query_data[] = "drop index dna_key_idx on ".DB_PREFIX."_dna";
        $query_data[] = "create unique index dna_key_idx on ".DB_PREFIX."_dna (group_id, component_id, function_id)";
        
        $rs = '<h3>'.Multilanguage::_('SQL_NOW','system').'</h3>';
        foreach ( $query_data as $query ) {
        	$this->db->exec($query);
        	if ( !$this->db->success ) {
        		$rs .= Multilanguage::_('ERROR_ON_SQL_RUN','system').': '.$query.', <b>'.$this->db->error.'</b><br>';
        	} else {
        		$rs .= Multilanguage::_('QUERY_SUCCESS','system').': '.$query.'<br>';
        	}
        }
        return $rs;
    }
}
