$(document).ready(function(){
    var fixHelper = function(e, ui) {
        ui.children().each(function() {
            $(this).width($(this).width());
        });
        return ui;
    };
    
    var appendEditableHandlerToField = function(el, field_name){
    	$(el).editable({
    		ajaxOptions: {dataType: "json"}, 
    		url: estate_folder+"/apps/table/js/ajax.php?action=change_column_field&field_name="+field_name, 
    		success: function(response, newValue) {
    			if(!response.success) {
    				return response.msg;
    			}
    		}
    	});
    };
    
    $.fn.editable.defaults.mode = 'inline';
    
    $('.addeditable').each(function(){
    	appendEditableHandlerToField(this,'title');
    });
    
    $(".applied").sortable({
    	stop: function( event, ui ) {
    		var parent=$(ui.item).parents('.accordion-group').eq(0);
    		if(parent.length!=1){
    			parent=$(ui.item).parents('table').eq(0);
    		}
    		if(parent.length==1){
    			var childs=parent.find('.column');
    			if(childs.length>0){
    				var ids=[];
    				var count=childs.length;
    				if(count>0){
    					for(var i=0; i<count; i++){
    						var alt=$(childs[i]).attr('alt');
    						if(alt!=''){
    							ids.push(alt);
    						}
    					}
    				}
    				if(ids.length>0){
    					$.ajax({
    						url: estate_folder + '/apps/table/js/ajax.php',
    						type: 'POST',
    						dataType: 'text',
    						data: 'action=reorder_columns&ids='+ids.join(','),
    						success: function(data) {
    							//alert(' ');
    						}
    					});
    				}
    			}
    			
    		}
    	}
    }).disableSelection();
    
    $('.field_tab').dblclick(function(){
    	var _this=$(this);
    	var content_element=$(this).find('span').clone();
    	var content='';
    	//console.log(content_element.hasClass('undefined'));
    	if(content_element.hasClass('undefined')){
    		content='';
    	}else{
    		content=content_element.text();
    	}
    	
    	
    	
    	var id=$(this).attr('alt');
    	_this.html('');
    	var new_content=$('<input type="text" value="'+content+'" />').blur(function(){
    		var c=new_content.val();
    		$.ajax({
    			url: estate_folder+'/apps/table/js/ajax.php',
    			type: 'POST',
    			dataType: 'text',
    			data: 'action=change_field_tab&tab_name='+c+'&id='+id,
    			success: function(data) {
    				if(data==''){
    					_this.html('');
    					_this.append(content_element);
    				}else if(data==' '){
    					_this.html('');
    					_this.append(content_element.text(data).removeClass('defined').addClass('undefined'));
    				}else{
    					_this.html('');
    					_this.append(content_element.text(data).removeClass('undefined').addClass('defined'));
    				}
    				//_this.html(c);
    			},
    			error: function(){
    				_this.append(content_element);
    			}
    		});
    		
    		//_this.html(c);
    	});
    	_this.append(new_content);
    	new_content.focus();
    	return false;
    });
    
    $('a.state_change').click(function(){
    	var ops=$(this).attr('href');
    	var id=$(this).attr('alt');
    	var a=this;
    	//$(this).find('img').attr('src',estate_folder+'/apps/admin/admin/template/img/active.png');
    	$.ajax({
			url: estate_folder+'/apps/table/js/ajax.php',
			type: 'POST',
			dataType: 'text',
			data: 'action=change_column_state&operation='+ops+'&id='+id,
			success: function(data) {
				if(data=='activated'){
		    		$(a).find('img').attr('src',estate_folder+'/apps/admin/admin/template/img/active.png');
		    		$(a).attr('href','deactivate');
		    		$(a).parents('tr').eq(0).removeClass('row3notactive').addClass('row3');
		    	}else if(data=='deactivated'){
		    		$(a).find('img').attr('src',estate_folder+'/apps/admin/admin/template/img/notactive.png');
		    		$(a).attr('href','activate');
		    		$(a).parents('tr').eq(0).removeClass('row3').addClass('row3notactive');
		    	}
			}
		});
    	return false;
    });
	
	
	$('.update_table').live('click',function(){
		var parent=$(this).parents('.accordion-group').eq(0);
		if(parent.length!=1){
			parent=$(this).parents('tr').eq(0);
		}
		if(parent.length==1){
			var childs=parent.find('.column');
			if(childs.length>0){
				var ids=[];
				var count=childs.length;
				if(count>0){
					for(var i=0; i<count; i++){
						var alt=$(childs[i]).attr('alt');
						if(alt!=''){
							ids.push(alt);
						}
					}
				}
				if(ids.length>0){
					$.ajax({
						url: estate_folder + '/apps/table/js/ajax.php',
						type: 'POST',
						dataType: 'text',
						data: 'action=reorder_columns&ids='+ids.join(','),
						success: function(data) {
							alert(' ');
						}
					});
				}
			}
			
		}
		return false;
	});
});