<?php
error_reporting(E_WARNING);
//error_reporting(E_ALL);
ini_set('display_errors','On');

if(!file_exists('./inc/db.inc.php')){
	header('location:./install/');
	exit();
}
session_start();
$settings=parse_ini_file('settings.ini.php',true);
if(isset($settings['Settings']['estate_folder'])AND($settings['Settings']['estate_folder']!='')){
$folder='/'.$settings['Settings']['estate_folder'];
}else{
$folder='';
}
$estate_folder = $folder;
global $home_url;
$home_url = '';
require_once("inc/db.inc.php");

$sitebill_document_root = $_SERVER['DOCUMENT_ROOT'].$folder;
define('SITEBILL_DOCUMENT_ROOT', $sitebill_document_root);
define('SITEBILL_MAIN_URL', $folder);
define('DB_PREFIX', $__db_prefix);
//  .              .
if(!defined('CURRENT_CURRENCY')){
	if(isset($_SESSION['current_currency'])){
		define('CURRENT_CURRENCY', $_SESSION['current_currency']);
	}else{
		define('CURRENT_CURRENCY', 1);
	}
}

ini_set("include_path", $include_path );

require_once(SITEBILL_DOCUMENT_ROOT.'/third/smarty/Smarty.class.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/init.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/db/MySQL.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/language/russian.php');
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/install/install.php');



$smarty = new Smarty;

$init = new Init();
$init->initGlobals();
$ETOWN_LANG = new Etown_Lang;
$install_manager = new Install_Manager();
if ( !$install_manager->main() ) {
    echo $install_manager->GetErrorMessage();
    exit;
}

if(isset($_REQUEST['_lang'])){
	$_SESSION['_lang']=$_REQUEST['_lang'];
}else{
	if(!isset($_SESSION['_lang'])){
		$_SESSION['_lang']='ru';
	}
}



require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/multilanguage/multilanguage.class.php';
Multilanguage::start('frontend',$_SESSION['_lang']);



$sitebill = new SiteBill();
if ( $sitebill->getConfigValue('show_demo_banners') ) {
    $available_themes = array('agency', 'onecity', 'realty', 'black_red', 'newcity1');
    $theme = 'agency';
    if ( $_GET['theme'] != '' ) {
        $_SESSION['theme'] = $_GET['theme']; 
        if ( in_array($_SESSION['theme'], $available_themes) ) {
            $theme = $_SESSION['theme'];
        }
    }
    
    if ( $_SESSION['theme'] != '' ) {
    	if ( in_array($_SESSION['theme'], $available_themes) ) {
    		$theme = $_SESSION['theme'];
    	}
    }
    
    $smarty->template_dir = SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$theme;
} else {
    $smarty->template_dir = SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$sitebill->getConfigValue('theme');
}
$smarty->cache_dir    = SITEBILL_DOCUMENT_ROOT.'/cache/smarty';
$smarty->compile_dir  = SITEBILL_DOCUMENT_ROOT.'/cache/compile';

$sitebill_krascap = new SiteBill_Krascap();
$sitebill_krascap->main();
$smarty->display("main.tpl");
exit;    
?>