<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Columns admin backend
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
require_once(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/admin.php');
class columns_admin extends table_admin {
    /**
     * Constructor
     */
    function __construct() {
        $this->SiteBill();
        $this->table_name='columns';
        $this->app_title=' ';
        $this->action = 'columns';
        $this->primary_key = 'columns_id';
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/columns/admin/columns_model.php');
        $Object=new columns_Model();
		$this->data_model=$Object->get_model();
		$this->data_model[$this->table_name]['primary_key_table']['select_data']=$this->getTablesNames();
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/table/admin/helper.php');
		$this->helper = new Admin_Table_Helper();
		
	}
	
	/**
	 * Main
	 * @param void
	 * @return string
	 */
	function main () {
		//echo 1;
		//exit();
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		$form_data = $this->data_model;
		$rs = $this->getTopMenu();
		if(0!=(int)$this->getRequestValue('table_id')){
			$rs .= '<h4> ID '.(int)$this->getRequestValue('table_id').'</h4>';
		}
	
		switch( $this->getRequestValue('do') ){
			case 'structure' : {
				$rs .= $this->structure_processor();
				break;
			}
	
			case 'edit_done' : {
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				/*
				echo '<pre>';
				print_r($form_data[$this->table_name]);
				echo '</pre>';
				*/
				unset($form_data[$this->table_name]['action']);
				if($form_data[$this->table_name]['dbtype']['value']!=1){
					$form_data[$this->table_name]['dbtype']['value']='notable';
				}else{
					$form_data[$this->table_name]['dbtype']['value']='';
				}
				
				$data_model->forse_auto_add_values($form_data[$this->table_name]);
				//$data_model->clear_auto_add_values(&$form_data[$this->table_name]);
				if ( !$this->check_data( $form_data[$this->table_name] ) ) {
					$rs .= $this->get_form($form_data[$this->table_name], 'edit');
				} else {
					$this->edit_data($form_data[$this->table_name]);
					if ( $this->getError() ) {
						$rs .= $this->get_form($form_data[$this->table_name], 'edit');
					} else {
						$this->db->exec('SELECT name FROM '.DB_PREFIX.'_table WHERE table_id='.$this->getRequestValue('table_id').' LIMIT 1');
						$this->db->fetch_assoc();
						$this->helper->update_table($this->db->row['name']);
						$_POST['table_name']=$this->db->row['name'];
						/*if($this->getConfigValue('apps.realtylog.enable')){
							require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
							$Logger=new realtylog_admin();
							$Logger->addLog($form_data['data']['id']['value'], $_SESSION['user_id_value'], 'edit', $this->table_name);
						}
						if($this->getConfigValue('apps.shoplog.enable')){
							require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
							$Logger=new shoplog_admin();
							$Logger->addLog($form_data[$this->table_name][$this->primary_key]['value'], $_SESSION['user_id_value'], 'edit', $this->table_name);
						}*/
						$rs .= $this->grid();
					}
				}
				break;
			}
	
			case 'edit' : {
				if ( $this->getRequestValue('subdo') == 'delete_image' ) {
					$this->deleteImage($this->table_name, $this->getRequestValue('image_id'));
				}
				 
				if ( $this->getRequestValue('subdo') == 'up_image' ) {
					$this->reorderImage($this->table_name, $this->getRequestValue('image_id'), $this->primary_key, $this->getRequestValue($this->primary_key),'up');
				}
				 
				if ( $this->getRequestValue('subdo') == 'down_image' ) {
					$this->reorderImage($this->table_name, $this->getRequestValue('image_id'), $this->primary_key, $this->getRequestValue($this->primary_key), 'down');
				}
				 
				//echo '<pre>';
				//print_r($form_data[$this->table_name]);
				if ( $this->getRequestValue('language_id') > 0 and !$this->language->get_version($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $this->getRequestValue('language_id')) ) {
					$rs .= $this->get_form($form_data[$this->table_name], 'new', $this->getRequestValue('language_id'));
				} else {
					if ( $this->getRequestValue('language_id') > 0 ) {
						$form_data[$this->table_name] = $data_model->init_model_data_from_db_language ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name], false, $this->getRequestValue('language_id') );
					} else {
						$form_data[$this->table_name] = $data_model->init_model_data_from_db ( $this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key), $form_data[$this->table_name] );
					}
					if($form_data[$this->table_name]['primary_key_table']['value']!=''){
						$form_data[$this->table_name]['primary_key_name']['select_data']=$this->getTableFields($form_data[$this->table_name]['primary_key_table']['value']);
						$form_data[$this->table_name]['value_name']['select_data']=$this->getTableFields($form_data[$this->table_name]['primary_key_table']['value']);
					}
					if($form_data[$this->table_name]['dbtype']['value']=='notable'){
						$form_data[$this->table_name]['dbtype']['value']=0;
					}else{
						$form_data[$this->table_name]['dbtype']['value']=1;
					}
					$rs .= $this->get_form($form_data[$this->table_name], 'edit');
				}
	
				break;
			}
			case 'delete' : {
				/*if($this->getConfigValue('apps.realtylog.enable')){
					require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
					$Logger=new realtylog_admin();
					$Logger->addLog($this->getRequestValue($this->primary_key), $_SESSION['user_id_value'], 'delete', $this->table_name);
				}
				if($this->getConfigValue('apps.shoplog.enable')){
					require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
					$Logger=new shoplog_admin();
					$Logger->addLog($this->getRequestValue($this->primary_key), $_SESSION['user_id_value'], 'delete', $this->table_name);
				}*/
				$this->delete_data($this->table_name, $this->primary_key, $this->getRequestValue($this->primary_key));
				if ( $this->getError() ) {
					$rs .= '<div align="center">   : '.$this->GetErrorMessage().'<br>';
					$rs .= '<a href="?action='.$this->action.'"></a>';
					$rs .= '</div>';
				} else {
					$rs .= $this->grid();
				}
	
	
				break;
			}
				
			case 'new_done' : {
				
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				unset($form_data[$this->table_name]['action']);
				
				$data_model->forse_auto_add_values($form_data[$this->table_name]);
				if($form_data[$this->table_name]['dbtype']['value']!=1){
					$form_data[$this->table_name]['dbtype']['value']='notable';
				}else{
					$form_data[$this->table_name]['dbtype']['value']='';
				}
				if ( !$this->check_data( $form_data[$this->table_name] ) ) {
					$rs .= $this->get_form($form_data[$this->table_name], 'new');
					 
				} else {
					$new_record_id=$this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
					if ( $this->getError() ) {
						$rs .= $this->get_form($form_data[$this->table_name], 'new');
					} else {
					    $query = "update ".DB_PREFIX."_columns set sort_order={$new_record_id} where columns_id={$new_record_id}";
					    $this->db->exec($query);
					    
					    $this->db->exec('SELECT name FROM '.DB_PREFIX.'_table WHERE table_id='.$this->getRequestValue('table_id').' LIMIT 1');
					    $this->db->fetch_assoc();
					    $this->helper->update_table($this->db->row['name']);
					    $_POST['table_name']=$this->db->row['name'];
						/*if($this->getConfigValue('apps.realtylog.enable')){
							require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
							$Logger=new realtylog_admin();
							$Logger->addLog($new_record_id, $_SESSION['user_id_value'], 'new', $this->table_name);
						}
						if($this->getConfigValue('apps.shoplog.enable')){
							require_once SITEBILL_DOCUMENT_ROOT.'/apps/shoplog/admin/admin.php';
							$Logger=new shoplog_admin();
							$Logger->addLog($new_record_id, $_SESSION['user_id_value'], 'new', $this->table_name);
						}*/
						$rs .= $this->grid();
					}
				}
				break;
			}
				
			case 'new' : {
				$form_data[$this->table_name]['table_id']['value']=$this->getRequestValue('table_id');
				//$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				$rs .= $this->get_form($form_data[$this->table_name]);
				break;
			}
			case 'mass_delete' : {
				$id_array=array();
				$ids=trim($this->getRequestValue('ids'));
				if($ids!=''){
					$id_array=explode(',',$ids);
				}
				$rs .= $this->mass_delete_data($this->table_name, $this->primary_key, $id_array);
				break;
			}
			default : {
				$rs .= $this->grid($user_id);
			}
		}
		$rs_new = $this->get_app_title_bar();
		$rs_new .= $rs;
		return $rs_new;
	}
	
	function get_form( $form_data=array(), $do = 'new', $language_id = 0, $button_title = '' ){
		global $smarty;
		if($button_title==''){
			$button_title = Multilanguage::_('L_TEXT_SAVE');
		}
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		
        $rs .= $this->get_ajax_functions();
        $rs .= '<script src="'.SITEBILL_MAIN_URL.'/apps/columns/js/interface.js"></script>';
        $rs .= '<div id="element_preview"><h3>  </h3><div id="element_preview_c">element_preview</div></div>';
		$rs .= '<form method="post" id="column_form" class="form-horizontal" action="index.php" enctype="multipart/form-data">';
		if ( $this->getError() ) {
			$smarty->assign('form_error',$form_generator->get_error_message_row($this->GetErrorMessage()));
		}
		$el = $form_generator->compile_form_elements($form_data, true);
		//array_unshift($el['public'][$this->getConfigValue('default_tab_name')], array('title'=>'','name'=>'_element_preview','html'=>'<div id="_element_preview"></div>'));
		//$el['public'][$this->getConfigValue('default_tab_name')]['_element_preview']=array('title'=>'','name'=>'_element_preview','html'=>'<div id="_element_preview"></div>');
		//echo '<pre>';
		//print_r($form_data);
		//echo '</pre>';
		if ( $do == 'new' ) {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="new_done" />');
			$el['private'][]=array('html'=>'<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'" />');
		} else {
			$el['private'][]=array('html'=>'<input type="hidden" name="do" value="edit_done" />');
			$el['private'][]=array('html'=>'<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'" />');
		}
		$el['private'][]=array('html'=>'<input type="hidden" name="action" value="'.$this->action.'">');
		$el['private'][]=array('html'=>'<input type="hidden" name="language_id" value="'.$language_id.'">');
		
		$el['form_header']=$rs;
		$el['form_footer']='</form>';
			
		/*if ( $do != 'new' ) {
			$el['controls']['apply']=array('html'=>'<button id="apply_changes" class="btn btn-info">'.Multilanguage::_('L_TEXT_APPLY').'</button>');
		}*/
		$el['controls']['submit']=array('html'=>'<button id="formsubmit" type="submit" name="submit" class="btn btn-primary">'.$button_title.'</button>');
			
		
		
		
		
		$smarty->assign('form_elements',$el);
		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl')){
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/template/form_data.tpl';
		}else{
			$tpl_name=SITEBILL_DOCUMENT_ROOT.'/apps/admin/admin/template/data_form.tpl';
		}
		return $smarty->fetch($tpl_name);
		
		
		
		
		
		
		
		
		$rs .= '<table>';
		if ( $this->getError() ) {
		    $rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		$rs .= $form_generator->compile_form($form_data);
		
		if ( $do == 'new' ) {
		    $rs .= '<input type="hidden" name="do" value="new_done">';
		    $rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		} else {
		    $rs .= '<input type="hidden" name="do" value="edit_done">';
		    $rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'">';
		}
		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="language_id" value="'.$language_id.'">';
		$rs .= '<tr>';
		$rs .= '<td></td>';
		$rs .= '<td><input type="submit" name="submit" id="formsubmit" value="'.$button_title.'"></td>';
		$rs .= '</tr>';
		$rs .= '</table>';
		
		$rs .= '</form>';
		
		return $rs;
	}
	
}