<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * Getrent fronend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class getrent_site extends getrent_admin {

	
	
	function frontend () {
		global $smarty;
		$this->type='question';
		if ( !$this->getConfigValue('apps.getrent.enable') ) {
			return false;
		}
		if(preg_match('/\/getrent\//', $_SERVER['REQUEST_URI'])){
			
		$breadcrumbs[]='<a href="/">'.Multilanguage::_('L_HOME').'</a>';
		$breadcrumbs[]=$this->getConfigValue('apps.getrent.title');
		$this->template->assert('title', $this->getConfigValue('apps.getrent.title'));
		$this->template->assert('breadcrumbs', implode(' / ',$breadcrumbs));
		
			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
			$data_model = new Data_Model();
			
			
			$this->data_model[$this->table_name]['captcha']['name'] = 'captcha';
			$this->data_model[$this->table_name]['captcha']['title'] = ' ';
			$this->data_model[$this->table_name]['captcha']['value'] = '';
			$this->data_model[$this->table_name]['captcha']['length'] = 40;
			$this->data_model[$this->table_name]['captcha']['type'] = 'captcha';
			$this->data_model[$this->table_name]['captcha']['required'] = 'on';
			$this->data_model[$this->table_name]['captcha']['unique'] = 'off';
			
			$form_data = $this->data_model;
		
			switch( $this->getRequestValue('do') ){
				case 'new_done' : {
					$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
					
					
					$data_model->forse_auto_add_values($form_data[$this->table_name]);
					if ( !$this->check_data( $form_data[$this->table_name] ) ) {
						$rs = $this->get_form($form_data[$this->table_name], 'new');
						 
					} else {
						unset($form_data[$this->table_name]['captcha']);
						$new_record_id=$this->add_data($form_data[$this->table_name], $this->getRequestValue('language_id'));
						if ( $this->getError() ) {
							$rs = $this->get_form($form_data[$this->table_name], 'new');
						} else {
							$rs = '   ,    ';
						}
					}
					break;
				}
					
				default : {
					$smarty->assign('description',$this->getConfigValue('apps.getrent.description'));
						
					$rs = $this->get_form($form_data[$this->table_name]);
				}
			}
			
			$smarty->assign('main',$rs);
			$this->set_apps_template('getrent', $this->getConfigValue('theme'), 'main_file_tpl', 'main.tpl.html');
			return true;
		}
		return false;
	}
	
	
	function get_form ( $form_data=array(), $do = 'new', $language_id = 0, $button_title = '' ) {
	
		if($button_title==''){
			$button_title = Multilanguage::_('L_TEXT_SAVE');
		}
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		 
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
	
		$rs .= $this->get_ajax_functions();
		$rs .= '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script>';
		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
		if(1==$this->getConfigValue('use_combobox')){
			$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
			$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
		}
	
	
		$rs .= '<form method="post" action="index.php" enctype="multipart/form-data">';
		$rs .= '<table>';
		if ( $this->getError() ) {
			$rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		$rs .= $form_generator->compile_form($form_data);
	
		if ( $do == 'new' ) {
			$rs .= '<input type="hidden" name="do" value="new_done">';
			$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		} else {
			$rs .= '<input type="hidden" name="do" value="edit_done">';
			$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'">';
		}
		//$rs .= '<input type="hidden" name="page" value="'.$_SESSION['rem_page'].'">';
		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="language_id" value="'.$language_id.'">';
	
		if($this->getConfigValue('post_form_agreement_enable')==1){
			 
			$rs .= '<script type="text/javascript">';
			$rs.='$(document).ready(function(){';
			$rs.='	if($("#i_am_agree_in_form").attr("checked")){';
	
			$rs.='	}else{';
			$rs.='		$("#getrent_submit").attr("disabled","disabled");';
			$rs.='	}';
			 
			$rs.='	$("#i_am_agree_in_form").change(function(){';
			$rs.='			if($(this).attr("checked")){';
			$rs.='				$("#getrent_submit").removeAttr("disabled");';
			 
			$rs.='			}else{';
			$rs.='				$("#getrent_submit").attr("disabled","disabled");';
			 
			$rs.='			}';
			 
			 
			//$rs.=' $("#getrent_submit").toggle();';
			 
			$rs.='});';
			
			
			 
			$rs.='});';
			$rs .= '</script>';
			 
			//$rs .= '</script>';
			$rs .= '<tr>';
			$rs .= '<td><input type="checkbox" id="i_am_agree_in_form" /></td><td>'.$this->getConfigValue('post_form_agreement_text').'</td>';
			$rs .= '</tr>';
		}
		
		/*$rs .= '<script type="text/javascript">';
		$rs.='$(document).ready(function(){';
		$rs.='$("#getrent_submit").click(function(){$(this).replaceWith("   ..."); return true;});';
		$rs.='});';
		$rs .= '</script>';*/
		
		$rs .= '<tr>';
		$rs .= '<td></td><td><input type="submit" value="" id="getrent_submit"></td>';
		$rs .= '</tr>';
		$rs .= '</table>';
		$rs .= '</form>';
	
		return $rs;
	
	}
	
	
	
	
}