<?php
require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
/**
 * Grid constructor
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class News_Grid_Constructor extends Grid_Constructor {
    /**
     * Constructor
     */
    function __construct() {
        parent::__construct();
    }
    
    /**
     * Main
     * @param array $param
     * @return array
     */
    function main ( $params ) {
    	//require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        //$Structure_Manager = new Structure_Manager();
        //$category_structure = $Structure_Manager->loadCategoryStructure();
        
        //$res = $this->get_sitebill_adv_ext( $params );
        //$this->template->assign('category_tree', $this->get_category_tree( $params, $category_structure ) );
        //$this->template->assign('breadcrumbs', $this->get_category_breadcrumbs( $params, $category_structure ) );
        //$this->get_sales_grid($res);
    }
    
   
    
    
    
   
    
    /**
     * Get sitebill adv ext
     * @param array $params
     * @param boolean $random
     * @return array
     */
    function get_sitebill_adv_ext( $params, $random = false ) {
    	
    	/*
    	$where_array = false;

        if ( $where_array ) {
            $where_statement = " where ".implode(' and ', $where_array);
        }
        
        if ( isset($params['order']) ) {

            if ( !isset($params['asc']) ) {
                $asc = 'desc';
            } 
            elseif ($params['asc'] == 'asc')  $asc = 'asc';
            elseif ($params['asc'] == 'desc') $asc = 'desc';
            //
            if     ( $params['order'] == 'type' ) $order = 'type_sh ';
            elseif ( $params['order'] == 'street' ) $order = 're_street.name ';
            elseif ( $params['order'] == 'district' ) $order = 're_district.name ';
            elseif ( $params['order'] == 'metro' ) $order = 're_metro.name ';
            elseif ( $params['order'] == 'city' ) $order = 're_city.name ';
            elseif ( $params['order'] == 'price' ) $order = 're_data.price ';

            $order .= $asc;
        } else {
            $order = DB_PREFIX."_news.date DESC";
        }
        */
        $order = DB_PREFIX."_news.date DESC, news_id DESC";
        if ( !isset($params['page']) or $params['page'] == 0 ) {
            $page = 1;
        } else {
            $page = $params['page'];
        }
        
        if ( !isset($params['per_page']) OR $params['per_page'] == 0 ) {
        	$limit = $this->getConfigValue('apps.news.front.per_page');
        }else{
        	$limit=$params['per_page'];
        }
		
        
		$start = ($page-1)*$limit;
		if ( $random ) {
		    $order = ' RAND() ';
		}
        
		$query = "SELECT COUNT(".DB_PREFIX."_news.news_id) AS total FROM ".DB_PREFIX."_news $add_from_table $where_statement ORDER BY $order";
		$this->db->exec($query);
		$this->db->fetch_assoc();
		$total = $this->db->row['total'];
		
		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/page_navigator.php';
		$Pager=new Page_Navigator($total,$page,$limit,'',array('pre_pages'=>'3','post_pages'=>'3'));
		$this->template->assert('pager', $Pager->getPagerArray());		
		
		/*
		unset($params['per_page']);
		
		unset($params['order']);
        unset($params['asc']);
        
	    foreach ( $params as $key => $value ) {
	        if ( $value != '') {
	        	if($key!='topic_id'){
	                //echo "key = $key, value = $value<br>";
		            $pairs[] = "$key=$value";
	        	}
	        }
	    }
      
	    if ( is_array($pairs) ) {
		    $url = $pageurl.'?'.implode('&', $pairs);
	    }else{
	    	$url = $pageurl.'?key=value';
	    }
        $this->template->assert('url', $url);		
		*/
                
        $query="SELECT * FROM ".DB_PREFIX."_news ".$add_from_table." ".$where_statement." ORDER BY ".$order." LIMIT ".$start.", ".$limit;
        $this->db->exec($query);
        $ra = array();
        while($row=$this->db->fetch_assoc()){
        	$ra[]=$this->db->row;
        }
	            
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $params = array();
        
        foreach ( $ra as $item_id => $item_array ) {
            $ra[$item_id]['date'] = date('d.m.Y',$ra[$item_id]['date']);
            $image_array = $data_model->get_image_array ( 'news', 'news', 'news_id', $item_array['news_id'] );
            if ( count($image_array) > 0 ) {
            	$ra[$item_id]['prev_img']=$image_array[0]['img_preview'];
                $ra[$item_id]['img'] = $image_array;
            }
        } 
        return $ra;
    }
 }
?>
