<?php
defined('SITEBILL_DOCUMENT_ROOT') or die('Restricted access');
/**
 * News fronend
 * @author Abushyk Kostyantyn <abushyk@gmail.com> http://www.sitebill.ru
 */
class news_site extends news_admin {
	
	function frontend () {
		if ( !$this->getConfigValue('apps.news.enable') ) {
			return false;
		}
		$query='';
    	$breadcrumbs=array();
    	$breadcrumbs[]='<a href="'.(SITEBILL_MAIN_URL!='' ? SITEBILL_MAIN_URL : '').'/">'.Multilanguage::_('L_HOME').'</a>';
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/tab.php');
    	
    	if(preg_match('/\/news/', $_SERVER['REQUEST_URI'])){
    		
    		if(preg_match('/news(\d+).html/', $_SERVER['REQUEST_URI'], $matches)){
    			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/news/admin/news_model.php');
				$Object=new News_Model();
				$model=$Object->get_model();
				$news=$Object->init_model_data_from_db($this->table_name, $this->primary_key, $matches[1], $model[$this->table_name], TRUE);
    			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    		$data_model = new Data_Model();
				$image_array = $data_model->get_image_array ( 'news', 'news', 'news_id', $news['news_id']['value'] );
	    		if ( count($image_array) > 0 ) {
	            	$news['prev_img']=$image_array[0]['img_preview'];
	            	$news['normal_img']=$image_array[0]['img_normal'];
	            	$news['img'] = $image_array;
	            }
	            if ( preg_match('/\./', $news['date']['value']) ) {
	            	$news['date']['value_string']=$news['date']['value'];
	            } else {
	            	$news['date']['value_string']=date('d.m.Y',$news['date']['value']);
	            }
				$breadcrumbs[]='<a href="'.(SITEBILL_MAIN_URL!='' ? SITEBILL_MAIN_URL : '').'/news/">'.Multilanguage::_('PAGE_TITLE','news').'</a>';
				$breadcrumbs[]='<a href="'.(SITEBILL_MAIN_URL!='' ? SITEBILL_MAIN_URL : '').'/news'.$news['news_id']['value'].'.html">'.$news['title']['value'].'</a>';
				$this->template->assert('breadcrumbs', $this->get_breadcrumbs($breadcrumbs));
				$this->template->assert('title', $news['title']['value']);
				$this->template->assert('news', $news);
				$this->template->assert('more_news', $this->get_more_news($news['news_id']['value']));
				$this->set_apps_template('news', $this->getConfigValue('theme'), 'main_file_tpl', 'news_view.tpl');
    			return true;
    		}else{
    			$breadcrumbs[]=Multilanguage::_('PAGE_TITLE','news');
    			$page=(int)$this->getRequestValue('page');
    			$per_page=$this->getConfigValue('apps.news.front.per_page');
    			$this->template->assert('breadcrumbs', $this->get_breadcrumbs($breadcrumbs));
    			require_once SITEBILL_DOCUMENT_ROOT.'/apps/news/site/news_grid_constructor.php';
    			$NGC=new News_Grid_Constructor();
    			$news=$NGC->get_sitebill_adv_ext(array('page'=>$page,'per_page'=>$per_page));
    			$this->template->assert('title', Multilanguage::_('PAGE_TITLE','news'));
    			$this->template->assert('news', $news);
    			 
    			$this->set_apps_template('news', $this->getConfigValue('theme'), 'main_file_tpl', 'news_grid.tpl');
    			return true;
    		}
    		return true;
    	}
    	
		//echo 2;
		return false;
    }
    
    function get_more_news ( $current_news_id ) {
        $news=array();
        $count=$this->getConfigValue('apps.news.news_line.per_page');
        if($count==0){
        	$count=4;
        }
        $query='SELECT * FROM '.DB_PREFIX.'_'.$this->table_name.' where news_id <> '.$current_news_id.' ORDER BY `date` DESC LIMIT '.$count;
        //echo $query;
        $this->db->exec($query);
        if($this->db->success){
        	while($this->db->fetch_assoc()){
        		$this->db->row['date']=date('d.m.Y',$this->db->row['date']);
        		$news[]=$this->db->row;
        	}
        
        }
        if(count($news)>0){
        
        	foreach($news as $k=>$n){
        		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
        		$data_model = new Data_Model();
        		$image_array = $data_model->get_image_array ( 'news', 'news', 'news_id', $n['news_id'] );
        		if ( count($image_array) > 0 ) {
        			$news[$k]['prev_img']=$image_array[0]['img_preview'];
        			//$ra[$item_id]['img'] = $image_array;
        		}
        
        	}
        }
        //print_r($news);
        return $news;
    }
    
    function getNewsList(){
    	$news=array();
    	$count=$this->getConfigValue('apps.news.news_line.per_page');
    	if($count==0){
    		$count=4;
    	}
    	$query='SELECT * FROM '.DB_PREFIX.'_'.$this->table_name.' ORDER BY `date` DESC LIMIT '.$count;
    	//echo $query;
    	$this->db->exec($query);
    	if($this->db->success){
    		while($this->db->fetch_assoc()){
    			$this->db->row['date']=date('d.m.Y',$this->db->row['date']);
    			$news[]=$this->db->row;
    		}
    		
    	}
    	if(count($news)>0){
    		
    		foreach($news as $k=>$n){
	    		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		    	$data_model = new Data_Model();
		    	$image_array = $data_model->get_image_array ( 'news', 'news', 'news_id', $n['news_id'] );
	            if ( count($image_array) > 0 ) {
	            	$news[$k]['prev_img']=$image_array[0]['img_preview'];
	                //$ra[$item_id]['img'] = $image_array;
	            }
	        	
    		}
    	}
    	//print_r($news);
    	return $news;
    }
    
	
	
}