function update_child_list ( id, context ) {
	if(context===undefined || context===null){
		return;
	}
	
	var parent=$(context).parents('form').eq(0);
	
	parent.find('[id='+ id +'_div]').html('<div id="select_box_loading"></div>');
	
	var country_id = parent.find('#country_id').val();
	var region_id = parent.find('#region_id').val();
	var city_id = parent.find('#city_id').val();
	var district_id = parent.find('#district_id').val();
	var metro_id = parent.find('#metro_id').val();
	var street_id = parent.find('#street_id').val();

	var url = estate_folder+'/js/ajax.php?action=get_'+ id +'&country_id='+ country_id  +'&region_id='+ region_id +'&city_id='+ city_id +'&district_id='+ district_id +'&metro_id='+ metro_id +'&street_id='+ street_id + '&callback=?';

	//console.log(url);
	
	jQuery.ajax({
		url: url, 
		dataType: 'json', 
		type: "get",
		timeout: 2000,
		success: function(json){
			parent.find('[id='+ id +'_div]').replaceWith(json.response.body).fadeIn('slow', function() {}); 
		},
		error: function(){alert("error");}
	});

}

function update_child_list_multiple ( id ) {
	jQuery('#'+ id +'_div').html('<div id="select_box_loading"></div>');
	
	var country_id = jQuery('#country_id').val();
	var region_id = jQuery('#region_id').val();
	var city_id = jQuery('#city_id').val();
	var district_id = jQuery('#district_id').val();
	var metro_id = jQuery('#metro_id').val();
	var street_id = jQuery('#street_id').val();
	
	var url = estate_folder+'/js/ajax.php?action=get_'+ id +'&country_id='+ country_id  +'&region_id='+ region_id +'&city_id='+ city_id +'&district_id='+ district_id +'&metro_id='+ metro_id +'&street_id='+ street_id +'&multiple_mode=yes' + '&callback=?';
	
	jQuery.getJSON(url, {}, function(json){
	
	jQuery('#'+ id +'_div').replaceWith(json.response.body);
	jQuery('#'+ id +'_div').fadeIn('slow', function() {
	    // Animation complete.
	});         
	});
}

function set_empty ( id, context ) {
	if(context===undefined || context===null){
		return;
	}
	var parent=$(context).parents('form').eq(0);
	parent.find('#'+ id +'_div').html('');
}