<?php
/**
 * User add (not login)
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class User_Add extends Object_Manager {
    /**
     * Constructor
     */
    function __construct() {
        global $smarty;
        $smarty->assign('search_form_template', '');
        $this->SiteBill();
        $this->table_name = 'data';
        $this->action = 'data';
        $this->primary_key = 'id';
	    
        require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
		
		
	    
        $this->data_model = $data_model->get_kvartira_model($this->getConfigValue('ajax_form_in_user'));
        
        
        $this->data_model[$this->table_name]['captcha']['name'] = 'captcha';
        $this->data_model[$this->table_name]['captcha']['title'] = ' ';
        $this->data_model[$this->table_name]['captcha']['value'] = '';
        $this->data_model[$this->table_name]['captcha']['length'] = 40;
        $this->data_model[$this->table_name]['captcha']['type'] = 'captcha';
        $this->data_model[$this->table_name]['captcha']['required'] = 'on';
        $this->data_model[$this->table_name]['captcha']['unique'] = 'off';
        
        $this->data_model[$this->table_name]['user_id']['value'] = $this->getUnregisteredUserId();
        $this->data_model[$this->table_name]['user_id']['type'] = 'hidden';
        
        $this->data_model[$this->table_name]['date_added']['value'] = date('Y-m-d H:i:s');
        $this->data_model[$this->table_name]['date_added']['type'] = 'hidden';
        
        $this->data_model[$this->table_name]['hot']['type'] = 'hidden';
        $this->data_model[$this->table_name]['active']['type'] = 'hidden';
        
        if($this->getConfigValue('user_add_street_enable')!=1){
        	if(isset($this->data_model[$this->table_name]['new_street'])){
        		unset($this->data_model[$this->table_name]['new_street']);
        	}
        }
        
		/*
        $this->data_model['data']['user_id']['value'] = $this->getUnregisteredUserId();
	    $this->data_model['data']['user_id']['type'] = 'hidden';
        
	    $this->data_model['data']['date_added']['name'] = 'date_added';
	    $this->data_model['data']['date_added']['title'] = 'date_added';
	    $this->data_model['data']['date_added']['value'] = date('Y-m-d H:i:s');
	    $this->data_model['data']['date_added']['length'] = 40;
	    $this->data_model['data']['date_added']['type'] = 'hidden';
	    $this->data_model['data']['date_added']['required'] = 'off';
	    $this->data_model['data']['date_added']['unique'] = 'off';
	     
        $this->data_model['data']['fio']['name'] = 'fio';
		$this->data_model['data']['fio']['title'] = Multilanguage::_('L_FIO');
		$this->data_model['data']['fio']['value'] = '';
		$this->data_model['data']['fio']['length'] = 40;
		$this->data_model['data']['fio']['type'] = 'safe_string';
		$this->data_model['data']['fio']['required'] = 'on';
		$this->data_model['data']['fio']['unique'] = 'off';
		
		$this->data_model['data']['email']['name'] = 'email';
		$this->data_model['data']['email']['title'] = 'E-mail';
		$this->data_model['data']['email']['value'] = '';
		$this->data_model['data']['email']['length'] = 40;
		$this->data_model['data']['email']['type'] = 'email';
		if ( $this->getConfigValue('autoreg_enable') ) {
			$this->data_model['data']['email']['required'] = 'on';
		} else {
			$this->data_model['data']['email']['required'] = 'off';
		}
		$this->data_model['data']['email']['unique'] = 'off';
		
	    $this->data_model['data']['phone']['name'] = 'phone';
    	if ( $this->getConfigValue('theme') == 'albostar' ) {
			$this->data_model['data']['phone']['title'] = '  ()<br />  <b>8**********</b>';
		} else {
			$this->data_model['data']['phone']['title'] = ' ';
		}
		
		$this->data_model['data']['phone']['value'] = '';
		$this->data_model['data']['phone']['length'] = 40;
		$this->data_model['data']['phone']['type'] = 'mobilephone';
		if ( $this->getConfigValue('theme') == 'albostar' ) {
			$this->data_model['data']['phone']['required'] = 'on';
		} else {
			$this->data_model['data']['phone']['required'] = 'off';
		}
		$this->data_model['data']['phone']['unique'] = 'off';
		
		$this->data_model['data']['price']['name'] = 'price';
		if ( $this->getConfigValue('theme') == 'albostar' ) {
			$this->data_model['data']['price']['title'] = ' .';
		} else {
			$this->data_model['data']['price']['title'] = '';
		}
		$this->data_model['data']['price']['value'] = '';
		$this->data_model['data']['price']['length'] = 40;
		$this->data_model['data']['price']['type'] = 'price';
		$this->data_model['data']['price']['required'] = 'on';
		$this->data_model['data']['price']['unique'] = 'off';
        
        $this->data_model['data']['active']['name'] = 'active';
		$this->data_model['data']['active']['title'] = '  ';
		$this->data_model['data']['active']['value'] = 0;
		$this->data_model['data']['active']['length'] = 40;
		$this->data_model['data']['active']['type'] = 'hidden';
		$this->data_model['data']['active']['required'] = 'off';
		$this->data_model['data']['active']['unique'] = 'off';

		$this->data_model['data']['hot']['name'] = 'hot';
		$this->data_model['data']['hot']['title'] = '';
		$this->data_model['data']['hot']['value'] = 0;
		$this->data_model['data']['hot']['length'] = 40;
		$this->data_model['data']['hot']['type'] = 'hidden';
		$this->data_model['data']['hot']['required'] = 'off';
		$this->data_model['data']['hot']['unique'] = 'off';
		
		$this->data_model['data']['best']['name'] = 'best';
		$this->data_model['data']['best']['title'] = '';
		$this->data_model['data']['best']['value'] = 0;
		$this->data_model['data']['best']['length'] = 40;
		$this->data_model['data']['best']['type'] = 'hidden';
		$this->data_model['data']['best']['required'] = 'off';
		$this->data_model['data']['best']['unique'] = 'off';
		
		$this->data_model['data']['captcha']['name'] = 'captcha';
		$this->data_model['data']['captcha']['title'] = ' ';
		$this->data_model['data']['captcha']['value'] = '';
		$this->data_model['data']['captcha']['length'] = 40;
		$this->data_model['data']['captcha']['type'] = 'captcha';
		$this->data_model['data']['captcha']['required'] = 'on';
		$this->data_model['data']['captcha']['unique'] = 'off';
		
		if ( $this->getConfigValue('apps.realtypro.enable') ) {
			$this->data_model['data']['realty_type_id']['name'] = 'realty_type_id';
			$this->data_model['data']['realty_type_id']['title'] = '';
			$this->data_model['data']['realty_type_id']['value'] = 1; //
			$this->data_model['data']['realty_type_id']['length'] = 40;
			$this->data_model['data']['realty_type_id']['type'] = 'hidden';
			$this->data_model['data']['realty_type_id']['required'] = 'on';
			$this->data_model['data']['realty_type_id']['unique'] = 'off';
		}
		*/
    }
    
    /**
     * Main
     * @param void
     * @return string
     */
    function main () {
    	
    	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data = $this->data_model;
	    
		$rs = $this->getTopMenu();
		$this->template->assign('is_account', 1);

		switch( $this->getRequestValue('do') ){
			case 'new_done' : {
        		
	            $form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				$new_values=$this->getRequestValue('_new_value');
				if(1==$this->getConfigValue('use_combobox') && count($new_values)>0){
					$remove_this_names=array();
					foreach($form_data[$this->table_name] as $fd){
						if(isset($new_values[$fd['name']]) && $new_values[$fd['name']]!='' && $fd['combo']==1){
							$id=md5(time().'_'.rand(100,999));
							$remove_this_names[]=$id;
							$form_data[$this->table_name][$id]['value'] = $new_values[$fd['name']];
							$form_data[$this->table_name][$id]['type'] = 'auto_add_value';
							$form_data[$this->table_name][$id]['dbtype'] = 'notable';
							$form_data[$this->table_name][$id]['value_table'] = $form_data[$this->table_name][$fd['name']]['primary_key_table'];
							$form_data[$this->table_name][$id]['value_primary_key'] = $form_data[$this->table_name][$fd['name']]['primary_key_name'];
							$form_data[$this->table_name][$id]['value_field'] = $form_data[$this->table_name][$fd['name']]['value_name'];
							$form_data[$this->table_name][$id]['assign_to'] = $fd['name'];
							$form_data[$this->table_name][$id]['required'] = 'off';
							$form_data[$this->table_name][$id]['unique'] = 'off';
						}
					}
				}
				$data_model->forse_auto_add_values($form_data[$this->table_name]);
	    		if ( !$this->check_data( $form_data[$this->table_name] ) ) {
	    			$form_data[$this->table_name]=$this->removeTemporaryFields($form_data[$this->table_name],$remove_this_names);
			        $rs .= $this->get_form($form_data[$this->table_name], 'new');
			        
			    } else {
			    	unset($form_data[$this->table_name]['captcha']);
			        //$form_data[$this->table_name]['fio']['title'] = "<b> </b>";
			       	//$form_data[$this->table_name]['phone']['title'] = "<b> </b>";
			        $form_data[$this->table_name]['active']['value'] = 0;
			        $form_data[$this->table_name]['date_added']['value'] = date('Y-m-d H:i:s',time());
			         
			        if(1==$this->getConfigValue('autoreg_enable')){
			        	$uid=$this->quickAddUser($form_data[$this->table_name]['email']['value']);
			        	//unset($form_data[$this->table_name]['email']);			        	//var_dump($uid);
			        	if($uid==='error'){
			        		$rs = '<h1>'.Multilanguage::_('L_ERROR_ON_AUTOREGISTER').'</h1>';
			        	}elseif($uid===FALSE){
			        		$rs = '<h1>'.sprintf(Multilanguage::_('L_REGISTERED_EMAIL'),$form_data[$this->table_name]['email']['value']).'</h1>';
			        	}else{
			        		$form_data[$this->table_name]['user_id']['value']=$uid;
				        	$order_table = $this->add_data($form_data[$this->table_name]);
					        if($order_table!==FALSE){
					        	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
			
			                    $mailer = new Mailer();
			                    $subject = $_SERVER['SERVER_NAME'].': '.Multilanguage::_('NEW_ORDER','system');
			                    $to = ($this->getConfigValue('add_notification_email')!='' ? $this->getConfigValue('add_notification_email') : $this->getConfigValue('order_email_acceptor'));
			                    $from = $this->getConfigValue('order_email_acceptor');
			                    if ( $this->getConfigValue('use_smtp') ) {
			                        $mailer->send_smtp($to, $from, $subject, $order_table, 1);
			                    } else {
			                        $mailer->send_simple($to, $from, $subject, $order_table, 1);
			                    }
			                    
			                    $rs = '<h1>'.Multilanguage::_('L_MESSAGE_ORDER_ACCEPTED').'</h1>';
			                    $rs .= '<p>'.Multilanguage::_('L_MESSAGE_ON_MODERATION').'</p>';
			                    $rs .= '<form action="'.SITEBILL_MAIN_URL.'/"><input type="submit" value="OK" /></form>';
			                    $rs .= $order_table;
					        }else{
					        	$rs = '<h1>   .   .</h1>';
					        }
			        	}
			  		}else{
			  			//unset($form_data[$this->table_name]['email']);
			  			$form_data[$this->table_name]['user_id']['value']=$this->getUnregisteredUserId();
				        $order_table = $this->add_data($form_data[$this->table_name]);
				        if($order_table!==FALSE){
				        	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
		
		                    $mailer = new Mailer();
		                    $subject = $_SERVER['SERVER_NAME'].': '.Multilanguage::_('NEW_ORDER','system');
		                    $to = ($this->getConfigValue('add_notification_email')!='' ? $this->getConfigValue('add_notification_email') : $this->getConfigValue('order_email_acceptor'));
		                    $from = $this->getConfigValue('order_email_acceptor');
		                    if ( $this->getConfigValue('use_smtp') ) {
		                        $mailer->send_smtp($to, $from, $subject, $order_table, 1);
		                    } else {
		                        $mailer->send_simple($to, $from, $subject, $order_table, 1);
		                    }
		                    
		                    $rs = '<h1>'.Multilanguage::_('L_MESSAGE_ORDER_ACCEPTED').'</h1>';
		                    $rs .= '<p>'.Multilanguage::_('L_MESSAGE_ON_MODERATION').'</p>';
			                    $rs .= '<form action="'.SITEBILL_MAIN_URL.'/"><input type="submit" value="OK" /></form>';
		                    $rs .= $order_table;
				        }else{
				        	$rs = '<h1>'.Multilanguage::_('L_ERROR_ON_ADD').'. '.Multilanguage::_('L_MESSAGE_TRY_AGAIN_LATER').'.</h1>';
				        }
			        }
			    }
				break;
			}
			
			default : {
				$form_data[$this->table_name] = $data_model->init_model_data_from_request($form_data[$this->table_name]);
				$rs .= $this->get_form($form_data[$this->table_name]);
			}
		}
		return $rs;
	}
	
	function quickAddUser($email){
		$login=$email;
		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/users_manager.php';
		$fio = $this->getRequestValue('fio');
		$UM=new Users_Manager();
		if($UM->checkLogin($login)){
			$password=substr(md5(time()),1,6);
			$query="INSERT INTO ".DB_PREFIX."_user (login, password, email, active, fio) VALUES ('".mysql_real_escape_string($login)."','".md5($password)."','".$email."',1, '".mysql_real_escape_string($fio)."')";
			//echo $query;
			$this->db->exec($query);
			if ( !$this->db->success ) {
				return 'error';
	        } else {
	        	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/mailer/mailer.php');
	
                $mailer = new Mailer();
                $subject = $_SERVER['SERVER_NAME'].':   ';
                $body=sprintf(Multilanguage::_('L_MESSAGE_REGISTER_WELLCOME'),$_SERVER['SERVER_NAME'],$login,$password);
               	$to = $email;
                $from = $this->getConfigValue('order_email_acceptor');
                if ( $this->getConfigValue('use_smtp') ) {
                	$mailer->send_smtp($to, $from, $subject, $body, 1);
				} else {
					$mailer->send_simple($to, $from, $subject, $body, 1);
				}
	        	return $this->db->last_insert_id();
	        }
		}else{
			return FALSE;
		}
		
		
	}
	
	/**
	 * Get top menu
	 * @param void 
	 * @return string
	 */
	function getTopMenu () {
	    $rs = '';
	    $rs .= '<h1>'.Multilanguage::_('PLEASE_PUT_ORDER','system').'</h1>';
	    return $rs;
	}
    
	/**
	 * Add data
	 * @param array $form_data form data
	 * @return boolean
	 */
	function add_data ( $form_data ) {
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    $form_data['price']['value']=str_replace(' ', '', $form_data['price']['value']);
	    $new_record_id = parent::add_data($form_data);
	    
		if ( $new_record_id===FALSE ) {
		    echo $this->GetErrorMessage();
	        return FALSE;
	    }
	    
	    
	    
		if($this->getConfigValue('apps.realtylog.enable')){
        	require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
        	$Logger=new realtylog_admin();
        	$Logger->addLog($new_record_id, $this->getUnregisteredUserId(), 'new', $this->table_name);
        }
	    
	    $imgs=$this->editImageMulti('data', 'data', 'id', $new_record_id);
	    
	    if(1==$this->getConfigValue('apps.seo.data_alias_enable')){
	    	$this->saveTranslitAlias($new_record_id);
	    }
	    
	    if($this->getConfigValue('is_watermark')){
	    	$filespath = SITEBILL_DOCUMENT_ROOT.'/img/data/';
	    	require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/watermark/watermark.php';
	    	$Watermark=new Watermark();
	    	$Watermark->setPosition('bottom-left');
	    	$Watermark->setOffsets(array(20,50));
	    	if(!empty($imgs)){
	    		foreach($imgs as $v){
	    			//$Watermark->printWatermark($filespath.$v['preview']);
	    			$Watermark->printWatermark($filespath.$v['normal']);
	    		}
	    	}
	    }
	     
	    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/view/view.php');
	    $table_view = new Table_View();
        $rs .= '<table border="1" cellpadding="2" cellspacing="2" style="border: 1px solid gray;">';
	    $rs .= $table_view->compile_view($form_data);
	    $rs .= '</table>';
	    
	    /*
	    $query = $data_model->get_insert_query(DB_PREFIX.'_'.$this->table_name, $form_data);
	    //echo $query.'<br>';
	    
	    $this->db->exec($query);
	    $new_record_id = $this->db->last_insert_id();
	    //echo "new_record_id = $new_record_id<br>";
	    //echo $query;
	     */
	    return $rs;
	}
	
	
	/**
	 * Get form for edit or new record
	 * @param array $form_data
	 * @param string $do
	 * @param int $language_id
	 * @param string $button_title
	 * @return string
	 */
	function get_form ( $form_data=array(), $do = 'new', $language_id = 0, $button_title = '' ) {
		
		if(1==$this->getConfigValue('divide_step_form')){
			return $this->_get_form_step_divided($form_data, $do, $language_id, $button_title);
		}else{
			return $this->_get_form_standart($form_data, $do, $language_id, $button_title);
		}
		
		
		
		
	}
	
	function _get_form_step_divided($form_data=array(), $do = 'new', $language_id = 0, $button_title = ''){
		
		
		
		
		$requesturi=trim(parse_url($_SERVER['REQUEST_URI'],PHP_URL_PATH),'/');
		if(SITEBILL_MAIN_URL!=''){
			preg_replace('/^'.trim(SITEBILL_MAIN_URL,'/').'/','',$requesturi);
		}
		if(preg_match('/step(\d+)$/',$requesturi,$matches)){
			$step=(int)$matches[1];
		}else{
			$step=1;
		}
		
		$steps_names=$this->getSteps($form_data,$step);
		$last_step=$steps_names[count($steps_names)]['name'];
		
		if(isset($form_data['captcha'])){
			$form_data['captcha']['tab']=$last_step;
		}
		
		foreach($form_data as $k=>$v){
			if($v[type]=='uploadify_image'){
				$form_data[$k]['tab']=$last_step;
			}
		}
		$steps_names=$this->getSteps($form_data,$step);
		///////////
		//print_r($steps_names);
		$steps_total=count($steps_names);
		
		
		$Sitebill_Registry=Sitebill_Registry::getInstance();
		$Sitebill_Registry->addFeedback('divide_step_form',true);
		$Sitebill_Registry->addFeedback('step',$step);
		
		
		
		if($button_title==''){
			$button_title=Multilanguage::_('L_TEXT_SEND');
		}
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		 
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		
		$rs .= $this->get_ajax_functions();
		 
		$rs .= '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script>';
		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
		if(1==$this->getConfigValue('use_combobox')){
			$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
			$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
		}
		
		
		$rs .= '<div class="steps">';
		foreach($steps_names as $stepn){
			
			switch($stepn['status']){
				case 'current' : {
					$rs.='<div class="current"><a class="go_to_step" alt="'.$stepn['step'].'" href="/add/step'.$stepn['step'].'">'.$stepn['name'].'</a></div>';
					break;
				}
				case 'done' : {
					$rs.='<div class="done"><a class="go_to_step" alt="'.$stepn['step'].'" href="/add/step'.$stepn['step'].'">'.$stepn['name'].'</a></div>';
					break;
				}
				default :{
					$rs.= '<div class="future">'.$stepn['name'].'</div>';
				}
			}
			
			
			/*if($stepn['status'] < $step){
				$rs.='<a href="'.$step_i.'">'.$step_name.'</a>';
			}elseif($step_i > $step){
				$rs.=$step_name;
			}else{
				$rs.='<a href="'.$step_i.'">'.$step_name.'</a>';
			}*/
			
		}
		$rs .= '</div>';
		$rs .= '<div class="clear"></div>';
		//print_r($steps_names);
		//$rs.=implode(' | ',$steps_names);
		
		$form_content=$form_generator->compile_form($form_data);
		//echo $Sitebill_Registry->getFeedback('step').'_'.$Sitebill_Registry->getFeedback('steps');
		if($step < $steps_total){
			$rs .= '<form id="step_form" method="post" action="'.SITEBILL_MAIN_URL.'/add/step'.(1+$step).'" enctype="multipart/form-data" class="user_add_form">';
		}else{
			$rs .= '<form id="step_form" method="post" action="'.SITEBILL_MAIN_URL.'/add/step'.$steps_total.'" enctype="multipart/form-data" class="user_add_form">';
		}
		//$rs .= '<form method="post" action="'.SITEBILL_MAIN_URL.'/add/step'.(1+$Sitebill_Registry->getFeedback('step')).'" enctype="multipart/form-data" class="user_add_form">';
		$rs .= '<table>';
		if ( $this->getError() ) {
			$rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		//echo 'start compile<br>';
		$rs .= $form_content;
		 
		//$rs .= '<input type="hidden" name="do" value="new">';
		//$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		if($step < $steps_total){
			$rs .= '<input type="hidden" name="do" value="new">';
			$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		}else{
			if ( $do == 'new' ) {
				$rs .= '<input type="hidden" name="do" value="new_done">';
				$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
			} else {
				$rs .= '<input type="hidden" name="do" value="edit_done">';
				$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'">';
			}
		}
		 
		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="language_id" value="'.$language_id.'">';
		 
		 
		if($this->getConfigValue('post_form_agreement_enable')==1 && $step == $steps_total){
			 
			$rs .= '<script type="text/javascript">';
			$rs.='$(document).ready(function(){';
			$rs.='	if($("#i_am_agree_in_form").attr("checked")){';
			 
			$rs.='	}else{';
			$rs.='		$("#formsubmit").attr("disabled","disabled");';
			$rs.='	}';
			 
			$rs.='	$("#i_am_agree_in_form").change(function(){';
			$rs.='			if($(this).attr("checked")){';
			$rs.='				$("#formsubmit").removeAttr("disabled");';
			 
			$rs.='			}else{';
			$rs.='				$("#formsubmit").attr("disabled","disabled");';
			 
			$rs.='			}';
			$rs.='	});';
			 
			$rs.='});';
			$rs .= '</script>';
			 
			$rs .= '</script>';
			$rs .= '<tr>';
			$rs .= '<td><input type="checkbox" id="i_am_agree_in_form" />'.$this->getConfigValue('post_form_agreement_text_add').'</td>';
			$rs .= '</tr>';
		}
		 
		$rs .= '<tr>';
		if($step < $steps_total){
			$button_title=' ';
		}
	
		$rs .= '<td>';
		if($step>1){
			$rs .= '<input type="submit" name="submit" id="formsubmit_back" alt="'.($step-1).'" value="">';
		}
		$rs .= '<input type="submit" name="submit" id="formsubmit" value="'.$button_title.'">';
		$rs .= '</td>';
		 
		$rs .= '</tr>';
		$rs .= '</table>';
		$rs .= '</form>';
		$rs.='<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/system/css/form_tabs_divided.css" />';
		
		return $rs;
	}
	
	function getSteps($form_data,$step){
		
		$default_tab_name=$this->getConfigValue('default_tab_name');
		$tabs=array($default_tab_name);
		 
		foreach ( $form_data as $item_id => $item_array ) {
			if(isset($item_array['tab']) && $item_array['tab']!=''){
				$tabs[$item_array['tab']]=$item_array['tab'];
			}
		
		}
		//return array_values($tabs);
		/*$tabs_array=array();
		$i=1;
		foreach($tabs as $t){
			if($i<=$step){
				$tabs_array[$i]='<a class="step_done" href="">'.$t.'</a>';
			}else{
				$tabs_array[$i]='<a class="step_undone" href="'.SITEBILL_MAIN_URL.'/add/step'.$i.'">'.$t.'</a>';
			}
			
			$i++;
		}*/
		$tabs_array=array();
		$i=1;
		foreach($tabs as $t){
			if($i < $step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'done');
			}elseif($i==$step){
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'current');
			}else{
				$tabs_array[$i]=array('name'=>$t, 'step'=>$i, 'status'=>'further');
			}
			
			//$tabs_array[$i]=$t;
			$i++;
		}
		return $tabs_array;
	}
	
	function _get_form_standart($form_data=array(), $do = 'new', $language_id = 0, $button_title = ''){
		
		if($button_title==''){
			$button_title=Multilanguage::_('L_TEXT_SEND');
		}
		
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
		$data_model = new Data_Model();
		 
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
		
		$rs .= $this->get_ajax_functions();
		 
		$rs .= '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=true"></script>';
		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/geodata/js/geodata.js"></script>';
		$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/form_tabs.js"></script>';
		$rs .= '<link rel="stylesheet" type="text/css" href="'.SITEBILL_MAIN_URL.'/apps/system/css/form_tabs.css" />';
		
		if(1==$this->getConfigValue('use_combobox')){
			$rs .= '<script type="text/javascript" src="'.SITEBILL_MAIN_URL.'/apps/system/js/mycombobox.js"></script>';
			$rs .= '<link rel="stylesheet" href="'.SITEBILL_MAIN_URL.'/apps/system/css/mycombobox.css" />';
		}
		$rs .= '<form method="post" action="index.php" enctype="multipart/form-data" class="user_add_form">';
		$rs .= '<table>';
		if ( $this->getError() ) {
			$rs .= $form_generator->get_error_message_row($this->GetErrorMessage());
		}
		
		$rs .= $form_generator->compile_form($form_data);
		 
		
		if ( $do == 'new' ) {
			$rs .= '<input type="hidden" name="do" value="new_done">';
			$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$this->getRequestValue($this->primary_key).'">';
		} else {
			$rs .= '<input type="hidden" name="do" value="edit_done">';
			$rs .= '<input type="hidden" name="'.$this->primary_key.'" value="'.$form_data[$this->primary_key]['value'].'">';
		}
		 
		 
		$rs .= '<input type="hidden" name="action" value="'.$this->action.'">';
		$rs .= '<input type="hidden" name="language_id" value="'.$language_id.'">';
		 
		 
		if($this->getConfigValue('post_form_agreement_enable')==1){
			 
			$rs .= '<script type="text/javascript">';
			$rs.='$(document).ready(function(){';
			$rs.='	if($("#i_am_agree_in_form").attr("checked")){';
			 
			$rs.='	}else{';
			$rs.='		$("#formsubmit").attr("disabled","disabled");';
			$rs.='	}';
			 
			$rs.='	$("#i_am_agree_in_form").change(function(){';
			$rs.='			if($(this).attr("checked")){';
			$rs.='				$("#formsubmit").removeAttr("disabled");';
			 
			$rs.='			}else{';
			$rs.='				$("#formsubmit").attr("disabled","disabled");';
			 
			$rs.='			}';
			$rs.='	});';
			 
			$rs.='});';
			$rs .= '</script>';
			 
			$rs .= '</script>';
			$rs .= '<tr>';
			$rs .= '<td><input type="checkbox" id="i_am_agree_in_form" />'.$this->getConfigValue('post_form_agreement_text_add').'</td>';
			$rs .= '</tr>';
		}
		 
		$rs .= '<tr>';
		$rs .= '<td><input type="submit" name="submit" id="formsubmit" value="'.$button_title.'"></td>';
		$rs .= '</tr>';
		$rs .= '</table>';
		$rs .= '</form>';
	
		
		return $rs;
	}
	
	
}
?>
