<?php
/**
 * Ajax server class
 * @author Kondin Dmitriy <kondin@etown.ru> http://www.sitebill.ru
 */
class Ajax_Server extends SiteBill {
    /**
     * Construct
     */
    function __construct() {
        $this->SiteBill();
    }
    
    /**
     * Main
     * @param void
     * @return string
     */
    function main () {
    	global $estate_folder;
    	global $smarty;
    	$smarty->assign('estate_folder', $estate_folder);
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/form/form_generator.php');
		$form_generator = new Form_Generator();
	    
		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/model/model.php');
	    $data_model = new Data_Model();
	    
	    $kvartira_model = $data_model->get_kvartira_model(true);
        
        
        if($this->getRequestValue('_action')!=''){
        	switch($this->getRequestValue('_action')){
        		case 'save_changes' : {
        			
        			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
        			require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
        			
        			if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/data/data_manager.php') ) {
        				require_once (SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/data/data_manager.php');
        				$DM = new Data_Manager_Local();
        				//return 3;
        			} else {
        				$DM = new Data_Manager();
        				//return 2;
        			}
        			
        			
        			
        			
        			//$DM=new Data_Manager();
        			$Model=new Data_Model();
        			$form_data=$DM->data_model;
        			$table=$DM->table_name;
        			$form_data[$table] = $Model->init_model_data_from_request($form_data[$table]);
        			//return print_r($form_data,true);
        			foreach($form_data[$table] as $k=>$fd){
        				if(!is_array($form_data[$table][$k]['value'])){
        					$form_data[$table][$k]['value']=SiteBill::iconv('utf-8', SITE_ENCODING, $form_data[$table][$k]['value']);
        				}
        				
        			}
        			$data_model->forse_auto_add_values($form_data[$table]);
        			//$data_model->clear_auto_add_values($form_data[$this->table_name]);
        			if ( !$DM->check_data( $form_data[$table] ) ) {
        				return 'error';
        			} else {
        				$DM->edit_data($form_data[$table]);
        				if ( $DM->getError() ) {
        					return 'error';
        				} else {
        					if($this->getConfigValue('apps.realtylog.enable')){
        						require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylog/admin/admin.php';
        						$Logger=new realtylog_admin();
        						$Logger->addLog($form_data[$table]['id']['value'], $_SESSION['user_id_value'], 'edit', 'data');
        					}
        					if($this->getConfigValue('apps.realtylogv2.enable')){
        						require_once SITEBILL_DOCUMENT_ROOT.'/apps/realtylogv2/admin/admin.php';
        						$Logger=new realtylogv2_admin();
        						$Logger->addLog($form_data[$table]['id']['value'], $_SESSION['user_id_value'], 'edit', 'data', 'id');
        					}
        					return 'saved';
        				}
        			}
        			
        			//return print_r($form_data,true);
        			break;
        		}
        	}
        }
        
        switch ( $this->getRequestValue('action') ) {
        	case 'get_grid_data' : {
        		$params['page']=$this->getRequestValue('page');
        		$params['asc']=$this->getRequestValue('asc');
        		$params['order']=$this->getRequestValue('order');
        		//print_r($params);
        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
        		require_once SITEBILL_DOCUMENT_ROOT.'/template/frontend/mobile/grid/local_grid_constructor.php';
        		$grid_constructor = new Local_Grid_Constructor();
        		return $grid_constructor->main($params);
        		
        		/*require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php';
        		$dp = new SiteBill_Krascap();
        		return $dp->grid_adv_ajax($params);*/
        		
        		
        			//return $rs;
        		
        	}
        	
        	case 'collect_data' : {
        		if(file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/main/data_collector.php')){
        			require_once SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/main/data_collector.php';
        			$DC=new Data_Collector();
        			return $DC->collect_data();
        		}
        		return null;
        		break;
        	}
        	case 'get_form_element' :
        		$element_name=$this->getRequestValue('element');
        		//echo 1;
        		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
        		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
        		
        		
        		$DM=new Data_Manager();
        		//print_r($DM);
        		$body=$DM->get_element($element_name);
        		
        		return $body;
        		/*if($this->db->success){
        			$body = $answer;
        		}*/
        	
        	break;
			case 'go_up' :
				$body = '';
        		$id=(int)$this->getRequestValue('id');
				$date=date('Y-m-d H:i:s',time());
				$answer=date('d.m',time());
				$query='UPDATE '.DB_PREFIX.'_data SET date_added=\''.date('Y-m-d H:i:s',time()).'\' WHERE id='.$id;
				$this->db->exec($query);
				if($this->db->success){
					$body = $answer;
				}
				
			break;
			case 'get_form_fields_rules' : {
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/data/data_manager.php');
				require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
				$SM=new Structure_Manager();
				$category_structure=$SM->loadCategoryStructure();
				//return print_r($category_structure,true);
				if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/data/data_manager.php') ) {
					require_once (SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/admin/data/data_manager.php');
					$DM = new Data_Manager_Local();
				} else {
					$DM = new Data_Manager();
				}
				$form_data=$DM->data_model;
				$table=$DM->table_name;
				$r=array();
				if(!empty($form_data[$table])){
					foreach($form_data[$table] as $k=>$v){
						if(isset($v['active_in_topic']) && $v['active_in_topic']!=0){
							
							$topics=explode(',',$v['active_in_topic']);
							
							$active_array_ids = explode(',',$v['active_in_topic']);
							
							$child_cats = array();
							foreach ($active_array_ids as $item_id => $check_active_id) {
								//echo '$check_active_id = '.$check_active_id.'<br>';
								$child_cats_compare = $SM->get_all_childs($check_active_id, $category_structure);
								if ( is_array($child_cats_compare) ) {
									$child_cats = array_merge($child_cats, $child_cats_compare);
								}
								$child_cats[]=$check_active_id;
							}
							
							$r[$k] = $child_cats;
						}else{
							$r[$k][]='all';
						}
						
					}
				}
				//return print_r($r,true);
				return json_encode($r);
				return print_r($form_data,true);
				break;
			}
			case 'delete_image' : {
				$table=$this->getRequestValue('table_name');
				$image_id=(int)$this->getRequestValue('image_id');
				$data_id=(int)$this->getRequestValue('data_id');
				$key=$this->getRequestValue('key');
				$body='error';
				if($table=='' || $image_id==0 || $data_id==0){
					
				}else{
					if($_SESSION['user_id']=='true'){
						$this->deleteImage($table, $image_id);
						$body='ok';
					}elseif((int)$_SESSION['user_id']>0){
						if($table=='booking_apartment'){
							$query='SELECT user_id FROM '.DB_PREFIX.'_booking_hotel WHERE hotel_id=(SELECT hotel_id 
									FROM '.DB_PREFIX.'_'.$table.' 
									WHERE '.$key.'=(
											SELECT '.$key.' 
											FROM '.DB_PREFIX.'_'.$table.'_image 
											WHERE image_id='.$image_id.' AND '.$key.'='.$data_id.'
											))';
							
						}else{
							$query='SELECT user_id FROM '.DB_PREFIX.'_'.$table.' WHERE '.$key.'=(SELECT '.$key.' FROM '.DB_PREFIX.'_'.$table.'_image WHERE image_id='.$image_id.' AND '.$key.'='.$data_id.')';
						}
						//echo $query;
						$this->db->exec($query);
						if($this->db->success){
							$this->db->fetch_assoc();
							if((int)$this->db->row['user_id']==(int)$_SESSION['user_id']){
								$this->deleteImage($table, $image_id);
								$body='ok';
							}
						}
					}
				}
				return $body;
				break;
			}
			case 'reorder_image' : {
				$table=$this->getRequestValue('table_name');
				$image_id=(int)$this->getRequestValue('image_id');
				$key=$this->getRequestValue('key');
				$key_value=(int)$this->getRequestValue('key_value');
				$reorder=$this->getRequestValue('reorder');
				if($reorder=='up'){
					$this->reorderImage($table, $image_id, $key, $key_value, 'up');
				}elseif($reorder=='down'){
					$this->reorderImage($table, $image_id, $key, $key_value, 'down');
				}
				break;
			}
			case 'change_image_title' : {
				$title=$this->getRequestValue('title');
				$image_id=(int)$this->getRequestValue('image_id');
				if(get_magic_quotes_gpc()){
					$title=stripslashes($title);
				}
				$title=trim($title);
				$title=SiteBill::iconv('utf-8', SITE_ENCODING, $title);
				if($image_id!=0){
					$q='UPDATE '.DB_PREFIX.'_image SET title=\''.mysql_real_escape_string($title).'\' WHERE image_id='.$image_id;
					$this->db->exec($q);
				}
				return '';
			}
			
			case 'change_image_description' : {
				$description=$this->getRequestValue('description');
				$image_id=(int)$this->getRequestValue('image_id');
				if(get_magic_quotes_gpc()){
					$title=stripslashes($title);
				}
				$description=trim($description);
				$description=SiteBill::iconv('utf-8', SITE_ENCODING, $description);
				if($image_id!=0){
					$q='UPDATE '.DB_PREFIX.'_image SET description=\''.mysql_real_escape_string($description).'\' WHERE image_id='.$image_id;
					$this->db->exec($q);
				}
				return '';
			}
				
			case 'show_contact':
        		$body = '';
        		$id=(int)$this->getRequestValue('id');
        		if($id!=0){
        			$query='UPDATE '.DB_PREFIX.'_data SET show_contact=1 WHERE id='.$id;
        			$this->db->exec($query);
        			if($this->db->success){
        				$body = 'OK';
        			}
        		}
        	break;
			
			case 'get_districts_by_city_id':
			
        		$body = '';
        		$id=(int)$this->getRequestValue('loginreg-city_id');
        		if($id!=0){
        			$query='SELECT id, name FROM '.DB_PREFIX.'_district WHERE city_id='.$id;
        			$this->db->exec($query);
        			if($this->db->success){
						while($this->db->fetch_assoc()){
							$ret[]=array('district_id'=>$this->db->row['id'], 'name'=>SiteBill::iconv(SITE_ENCODING, 'utf-8', $this->db->row['name']));
						}
						
        				return json_encode($ret);
        			}
        		}
        	break;
        	case 'add_to_agentphones' : {
        		$phone=$this->getRequestValue('phone');
				$query="SELECT COUNT(*) AS added_yet FROM ".DB_PREFIX."_agentphones WHERE phone='".$phone."'";
				$this->db->exec($query);
				$this->db->fetch_assoc();
				if(0==$this->db->row['added_yet']){
					$query="INSERT INTO ".DB_PREFIX."_agentphones (phone) VALUES ('".$phone."')";
					$this->db->exec($query);
				}
           		break;
           	}
        	
        	case 'get_search_form':
        		global $smarty;
        		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/search/kvartira_search.php');
        		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
        		$Structure_Manager = new Structure_Manager();
        		
        		$this->template->assert('structure_box', $Structure_Manager->getCategorySelectBoxWithName('topic_id', $this->getRequestValue('topic_id') ));
        		
        		$kvartira_search_form = new Kvartira_Search_Form();
        		$kvartira_search_form->main();
        		$form_code = $smarty->fetch('search_form.tpl');
        		$ra = array();
        		$ra['response']['body'] = htmlentities( $form_code, ENT_QUOTES, 'CP1251');
        		return json_encode($ra);
        	break;
            case 'hide_contact':
        		$body = '';
        		$id=(int)$this->getRequestValue('id');
        		if($id!=0){
        			$query='UPDATE '.DB_PREFIX.'_data SET show_contact=0 WHERE id='.$id;
        			$this->db->exec($query);
        			if($this->db->success){
        				$body = 'OK';
        			}
        		}
            break;
            case 'add_to_favorites':
            	$id=(int)$this->getRequestValue('id');
        		if($id!=0){
        			if(!isset($_SESSION['favorites'][$id])){
        				$_SESSION['favorites'][$id] = $id;
        				$body = 'OK';
        			}else{
        				$body = '';
        			}
        		}
        	break;
        	case 'remove_from_favorites':
            	$id=(int)$this->getRequestValue('id');
        		if($id!=0){
        			if(isset($_SESSION['favorites'][$id])){
        				unset($_SESSION['favorites'][$id]);
        				$body = 'OK';
        			}else{
        				$body = '';
        			}
        		}
        	break;
        	
        	case 'get_specialoffers':
        		global $smarty;
        	
        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php';
        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
        		if ( $this->getConfigValue('theme') == 'kupikuban' ) {
        			require_once SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/main/grid_constructor_local.php';
        			$GC=new Grid_Constructor_Local();
        			$adv=$GC->vip_array(array('vip'=>'1'));
        		} else {
        			$GC=new Grid_Constructor();
        			$adv=$GC->get_sitebill_adv_ext(array('hot'=>'1'));
        		}
        		if ( $GC->get_grid_total_records() > 0 ) {
        			$this->template->assert('grid_items',$adv);
        			$rs=$smarty->fetch('realty_grid.tpl');
        		} else {
        			$rs = '<h2>'.Multilanguage::_('L_NO_HOT').'</h2>';
        		}

        		$ra['response']['body'] = htmlentities( $rs, ENT_QUOTES, 'CP1251');
        		return json_encode($ra);
        	
        	break;
        	case 'get_recomendation':
        		if ( file_exists(SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/grid/grid_constructor.php') ) {
        			global $smarty;
        			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php';
        			require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
        			require_once SITEBILL_DOCUMENT_ROOT.'/template/frontend/'.$this->getConfigValue('theme').'/grid/grid_constructor.php';
        			$GC=new Grid_Constructor_Local();
        			$adv=$GC->get_sitebill_adv_ext(array('recomendation'=>'1'));
        			
        			if ( $GC->get_grid_total_records() > 0 ) {
        				$this->template->assert('grid_items',$adv);
        				$rs=$smarty->fetch('realty_grid.tpl');
        			} else {
        				$rs = '<h2>'.Multilanguage::_('L_NO_RECOMENDATION').'</h2>';
        			}
        			 
        			$ra['response']['body'] = htmlentities( $rs, ENT_QUOTES, 'CP1251');
        			return json_encode($ra);
	       		}
        	break;
        	case 'get_station_list':
        		$this->db->exec('SELECT metro_id, LOWER(name) AS name FROM '.DB_PREFIX.'_metro');
        		while($this->db->fetch_assoc()){
        			$metro[]=array('id'=>$this->db->row['metro_id'],'name'=>SiteBill::iconv(SITE_ENCODING, 'utf-8', $this->db->row['name']));
        		}
        		return json_encode($metro);
        		break;
        		 
        	case 'get_my_favorites':
        		global $smarty;
        		
        		
        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/sitebill_krascap.php';
        		require_once SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/frontend/grid/grid_constructor.php';
        		$GC=new Grid_Constructor();
        		if ( count($_SESSION['favorites']) == 0 ) {
        			$rs = '<h2>'.Multilanguage::_('L_NO_FAVORITES').'</h2>';
        		} else {
        			$adv=$GC->get_sitebill_adv_ext(array('favorites'=>$_SESSION['favorites']));
        			 
        			$this->template->assert('grid_items',$adv);
        			//$smarty->assign('grid_items', $adv);
        			$rs=$smarty->fetch('realty_grid.tpl');
        		}
        		
        		$ra['response']['body'] = htmlentities( $rs, ENT_QUOTES, 'CP1251');
        		return json_encode($ra);
        		
        		//$body=$rs;
	        	
        	break;
            case 'remove_from_favorites':
            	if((int)$this->getRequestValue('id')!=0){
            		if(isset($_SESSION['favorites'][(int)$this->getRequestValue('id')])){
            			unset($_SESSION['favorites'][(int)$this->getRequestValue('id')]);
            		}
        		}
        		$body = 'OK';
            break;
        	case 'add_my_city':
        		if($this->getRequestValue('city_id')==''){
        			unset($_SESSION['city_id']);
        		}else{
        			$_SESSION['city_id'] = $this->getRequestValue('city_id');
        		}
        		$body = 'OK';
            break;
            case 'get_city_id':
                $body = $form_generator->get_single_select_box_by_query($kvartira_model['data']['city_id']);
                if ( $form_generator->get_total_in_select('city_id') == 0 ) {
                    $body = '<div id="city_id_div"></div>';
                }
            break;
            
            case 'get_region_id':
                $body = $form_generator->get_single_select_box_by_query($kvartira_model['data']['region_id']);
                if ( $form_generator->get_total_in_select('region_id') == 0 ) {
                    $body = '<div id="region_id_div"></div>';
                }
            break;
            
            case 'get_metro_id':
                $body = $form_generator->get_single_select_box_by_query($kvartira_model['data']['metro_id']);
                if ( $form_generator->get_total_in_select('metro_id') == 0 ) {
                    $body = '<div id="metro_id_div"></div>';
                }
            break;
            
            case 'get_district_id':
            	if('yes'==$this->getRequestValue('multiple_mode')){
            		$body = $form_generator->get_single_select_box_by_query_multiple($kvartira_model['data']['district_id']);
            	}else{
            		$body = $form_generator->get_single_select_box_by_query($kvartira_model['data']['district_id']);
            	}
                
                if ( $form_generator->get_total_in_select('district_id') == 0 ) {
                    $body = '<div id="district_id_div"></div>';
                }
            break;
            
            case 'get_street_id':
                $body = $form_generator->get_single_select_box_by_query($kvartira_model['data']['street_id']);
                if ( $form_generator->get_total_in_select('street_id') == 0 ) {
                    $body = '<div id="street_id_div"></div>';
                }
            break;
            
            
            case 'get_mark_list':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
                $structure_manager = new Structure_Manager();
                $body = $structure_manager->get_flat_mark_select_box($this->getRequestValue('parent_id'), 0, $current_mark_id);
            break;
            
            case 'get_coachwork_list':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
                $structure_manager = new Structure_Manager();
                $body = $structure_manager->get_flat_coachwork_select_box($this->getRequestValue('parent_id'), 0, $current_mark_id);
            break;
            
            case 'get_model_list':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
                $structure_manager = new Structure_Manager();
                $body = $structure_manager->get_flat_model_select_box($this->getRequestValue('mark_id'), $current_model_id);
            break;
            
            case 'get_modification_list':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/structure/structure_manager.php');
                $structure_manager = new Structure_Manager();
                $body = $structure_manager->get_flat_modification_select_box($this->getRequestValue('model_id'), $current_modification_id);
            break;
            
            case 'delete_user':
                if ( $_SESSION['group'] == 'nanoadmin' ) {
                    require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/users_manager.php');
                    $user_manager = new Users_Manager();
                    $user_manager->delete_user($this->getRequestValue('user_id'));
                }
            break;
            
            
            case 'register_complete':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/users_manager.php');
                $user_manager = new Users_Manager();
                
                $params['phone'] = $this->getRequestValue('phone');
                $params['mobile'] = $this->getRequestValue('mobile');
                $params['icq'] = $this->getRequestValue('icq');
                $params['site'] = $this->getRequestValue('site');
                $user_manager->add_ajax_user($this->getRequestValue('user_id'), $this->getRequestValue('fio'), $this->getRequestValue('email'), $params  );
            break;
            
            case 'ajax_login':
            	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/login.php');
            	$Login = new Login();
            	/*$userlogin=SiteBill::iconv('utf-8', SITE_ENCODING, $_GET['login']);
            	$userpassword=SiteBill::iconv('utf-8', SITE_ENCODING, $_GET['password']);*/
            	$userlogin=preg_replace('/([^a-zA-Z-_0-9])/', '', $_GET['login']);
            	$userpassword=$_GET['password'];
            	if(TRUE===$Login->checkLogin($userlogin, $userpassword)){
            		$body='Authorized';
	            	if($this->getConfigValue('apps.accountsms.enable')){
	            		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
	            		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/accountsms/admin/admin.php');
	            		require_once(SITEBILL_DOCUMENT_ROOT.'/apps/accountsms/site/site.php');
	            		$Accountsms_Site=new accountsms_site();
	            		$_SESSION['viewOptions']=$Accountsms_Site->getViewOptions($this->getSessionUserId());
	            	}
            	}
            break;
            
            case 'ajax_register':
            	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
            	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/users/user_object_manager.php');
            	require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/user/register_using_model.php');
            	$Register = new Register_Using_Model();
            	$this->setRequestValue('do', 'new_done');
            	$rs1 = $Register->ajaxRegister();
            	return $rs1;
            	break;
            
            case 'login':
                $_SESSION['user_id'] = $this->getRequestValue('user_id');
                $_SESSION['group'] = $this->getRequestValue('group');
                $_SESSION['session_key'] = $this->getRequestValue('session_key');
                $_SESSION['key'] = $this->getRequestValue('session_key');
                $user_ip = $_SERVER['REMOTE_ADDR'];
                
                $query = "insert into ".DB_PREFIX."_session (user_id, ip, session_key, start_date) values ('".$_SESSION['user_id']."', '$user_ip', '".$_SESSION['key']."', now())";
                $this->db->exec($query);
            break;
            
            case 'get_cart_count':
            	$items_count=0;
            	$summ=0;
				$positions_count=count($_SESSION['product_list']);
				if($positions_count!=0){
					foreach($_SESSION['product_list'] as $v){
						$items_count+=$v['count'];
						$summ+=$v['sum'];
					}
				}
				if(IS_NUKUPI==1){
					$body='   <a href="'.SITEBILL_MAIN_URL.'/cart/"></a> <br /><strong>'.$items_count.' </strong> <br /> <strong>'.$summ.' .</strong>';
				}else{
					$body=' ('.$items_count.')';
				}
			break;
            
            case 'check_address':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/ajax/check_address/check_address.php');
                $check_address = new Check_Address_Ajax();
                $body = $check_address->check($this->getRequestValue('address'));
            break;
            
        	case 'add_to_cart': 
                $product_data = $this->load_product_data($this->getRequestValue('product_id'));
                if ( $product_data ) {
                    $_SESSION['product_list'][$this->getRequestValue('product_id')]['product_name'] = $product_data['product_name'];
                    $_SESSION['product_list'][$this->getRequestValue('product_id')]['product_price'] = $product_data['product_price'];
                    $_SESSION['product_list'][$this->getRequestValue('product_id')]['product_id'] = $product_data['product_id'];
                    
                    $product_count = $_SESSION['product_list'][$this->getRequestValue('product_id')]['count'];
                    $product_count++; 
                    $_SESSION['product_list'][$this->getRequestValue('product_id')]['count'] = $product_count;
                    
                    $_SESSION['product_list'][$this->getRequestValue('product_id')]['sum'] = $product_data['product_price']*$product_count;
                    
                    $body = 'add '.$this->getRequestValue('product_id');
                } else {
                    $body = '  ';
                }
            break;
            
            case 'delete_from_cart': 
                $product_data = $this->load_product_data($this->getRequestValue('product_id'));
                unset($_SESSION['product_list'][$this->getRequestValue('product_id')]);
                
            break;
            
            case 'update_quantity':
            	$new_qty=$this->getRequestValue('quantity');
            	$product_id=$this->getRequestValue('product_id');
		        if($new_qty>0){
		    		$_SESSION['product_list'][$product_id]['count'] = $new_qty;
		        	$_SESSION['product_list'][$product_id]['sum'] = $_SESSION['product_list'][$product_id]['product_price']*$_SESSION['product_list'][$product_id]['count'];
		    	}else{
		    		unset($_SESSION['product_list'][$product_id]);
    			}
                
            break;
            
            case 'delete_uploadify_image':
            	$img_name=$this->getRequestValue('img_name');
            	$this->delete_uploadify_image($img_name);
            	$body = 'OK';
            break;
            
            case 'autocomplete':
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/admin/object_manager.php');
                require_once(SITEBILL_DOCUMENT_ROOT.'/apps/realtyautocomplete/lib/realty_autocomplete.php');
                $realty_autocomplete = new realty_autocomplete();
                $q = $_GET["term"];
                if (!$q) return;
                
                $result = $realty_autocomplete->generate_array($q);
                echo $this->array_to_json($result);
                exit;
            break;
            
            case 'get_vip_cost':
            	echo $this->getConfigValue('vip_cost');
            	exit;
            break;
            case 'make_special_payment': {
            	$user_id=$this->getSessionUserId();
            	$realty_id=(int)$this->getRequestValue('realty_id');
            	$days=(int)$this->getRequestValue('days');
            	$per_day=abs($this->getRequestValue('per_day'));
            	$payment_type=$this->getRequestValue('payment_type');
            	//if()
            	$sum=$days*$per_day;
            	if($user_id!=0 && $days>0 && in_array($payment_type,array('vip','premium','bold','buy_ups'))){
            		if($payment_type!='buy_ups' && $realty_id==0){
            			echo 'error';
            		}
            		
            		
            		$query='SELECT account FROM '.DB_PREFIX.'_user WHERE user_id='.$user_id;
            		$this->db->exec($query);
            		$this->db->fetch_assoc();
            		$current_account=$this->db->row['account'];
            		$last_account=$current_account-$sum;
            		if($last_account<0){
            			$html='    . <a href="'.SITEBILL_MAIN_URL.'/account/balance/?do=add_bill"> </a>';
            		}else{
            			if($payment_type=='vip'){
            				$query="INSERT INTO ".DB_PREFIX."_bill (`user_id`, `sum`, `date`, `description`, `status`)
            				VALUES (".(int)$user_id.",".$sum.",".time().",' VIP   ID=".$realty_id."   ".$days." ',1)";
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_user SET account='.$last_account.' WHERE user_id='.$user_id;
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_data SET vip_status_end='.(time()+$days*86400).' WHERE id='.$realty_id;
            				$this->db->exec($query);
            				
            				$html=' VIP ';
            			}elseif($payment_type=='premium'){
            				$query="INSERT INTO ".DB_PREFIX."_bill (`user_id`, `sum`, `date`, `description`, `status`)
            				VALUES (".(int)$user_id.",".$sum.",".time().",'    ID=".$realty_id."   ".$days." ',1)";
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_user SET account='.$last_account.' WHERE user_id='.$user_id;
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_data SET premium_status_end='.(time()+$days*86400).' WHERE id='.$realty_id;
            				$this->db->exec($query);
            				
            				$html='  ';
            			}elseif($payment_type=='bold'){
            				$query="INSERT INTO ".DB_PREFIX."_bill (`user_id`, `sum`, `date`, `description`, `status`)
            				VALUES (".(int)$user_id.",".$sum.",".time().",'    ID=".$realty_id."   ".$days." ',1)";
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_user SET account='.$last_account.' WHERE user_id='.$user_id;
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_data SET bold_status_end='.(time()+$days*86400).' WHERE id='.$realty_id;
            				$this->db->exec($query);
            				
            				$html='  ';
            			}elseif($payment_type=='buy_ups'){
            				$query="INSERT INTO ".DB_PREFIX."_bill (`user_id`, `sum`, `date`, `description`, `status`)
            				VALUES (".(int)$user_id.",".$sum.",".time().",'     ".$days."',1)";
            				$this->db->exec($query);
            				
            				$query='UPDATE '.DB_PREFIX.'_user SET account='.$last_account.' WHERE user_id='.$user_id;
            				$this->db->exec($query);
            				
            				$query='SELECT COUNT(user_id) AS cnt FROM '.DB_PREFIX.'_upper_packet WHERE user_id='.$user_id;
            				$this->db->exec($query);
            				$this->db->fetch_assoc();
            				if($this->db->row['cnt']>0){
            					$query='UPDATE '.DB_PREFIX.'_upper_packet SET quantity=quantity+'.$days.' WHERE user_id='.$user_id;
            				}else{
            					$query='INSERT INTO '.DB_PREFIX.'_upper_packet (`quantity`,`user_id`) VALUES ('.$days.','.$user_id.')';
            				}
            				
            				$this->db->exec($query);
            				
            				$html='  ';
            			}
            			
            
            			 
            		}
            		echo $html;
            	}else{
            		echo 'error';
            	}
            	exit;
            	break;
            }
            case 'add_bill': {
            	$resp=array(
            			'status'=>'error',
            			'data'=>array()
            		);
            	$user_id=$this->getSessionUserId();
            	$payment_value=$this->getRequestValue('payment_value');
            	if($user_id!=0 && $payment_value>0){
            		$query="INSERT INTO ".DB_PREFIX."_bill (`user_id`, `sum`, `date`, `description`, `status`)
            				VALUES (".(int)$user_id.",".$payment_value.",".time().",'   ID: ".(int)$user_id."',0)";
            		$this->db->exec($query);
            		if(!$this->db->success){
            			
            		}else{
            			$bill_id = $this->db->last_insert_id();
            			$signature=md5($this->getConfigValue('robokassa_login').':'.$payment_value.':'.$bill_id.':'.$this->getConfigValue('robokassa_password1'));
            			$resp['status']='ok';
            			$resp['data']=array('id'=>$bill_id, 'signature'=>$signature, 'sum'=>$payment_value);
            		}
            		
            		
            	}
            	return json_encode($resp);
            	exit;
            	break;
            }
            	
        }
        
                    
        $body = str_replace("\r\n", ' ', $body);
        $body = str_replace("\n", ' ', $body);
        $body = addslashes($body);
        
        
        $rs = '
{
   	"response":{
        "to":"Tove",
        "from":"Jani",
        "body":"'.$body.'"
    }
}
        ';
		
		if ( $_REQUEST['callback'] != '' ) {
            $rs = $_REQUEST['callback'].'('.$rs.')';
        }
        
        return $rs;
    }
    
    function array_to_json( $array ){
    
    	if( !is_array( $array ) ){
    		return false;
    	}
    
    	$associative = count( array_diff( array_keys($array), array_keys( array_keys( $array )) ));
    	if( $associative ){
    
    		$construct = array();
    		foreach( $array as $key => $value ){
    
    			// We first copy each key/value pair into a staging array,
    			// formatting each key and value properly as we go.
    
    			// Format the key:
    			if( is_numeric($key) ){
    				$key = "key_$key";
    			}
    			$key = "\"".addslashes($key)."\"";
    
    			// Format the value:
    			if( is_array( $value )){
    				$value = array_to_json( $value );
    			} else if( !is_numeric( $value ) || is_string( $value ) ){
    				$value = "\"".addslashes($value)."\"";
    			}
    
    			// Add to staging array:
    			$construct[] = "$key: $value";
    		}
    
    		// Then we collapse the staging array into the JSON form:
    		$result = "{ " . implode( ", ", $construct ) . " }";
    
    	} else { // If the array is a vector (not associative):
    
    		$construct = array();
    		foreach( $array as $value ){
    
    			// Format the value:
    			if( is_array( $value )){
    				$value = $this->array_to_json( $value );
    			} else if( !is_numeric( $value ) || is_string( $value ) ){
    				$value = "'".addslashes($value)."'";
    			}
    
    			// Add to staging array:
    			$construct[] = $value;
    		}
    
    		// Then we collapse the staging array into the JSON form:
    		$result = "[ " . implode( ", ", $construct ) . " ]";
    	}
    
    	return $result;
    }
    
    
	function load_product_data ( $product_id ) {
        $query = "SELECT * FROM ".DB_PREFIX."_shop_product WHERE product_id=$product_id";
        //echo $query;
        $this->db->exec($query);
        $this->db->fetch_assoc();
        if ( $this->db->row['product_id'] > 0 ) {
            return $this->db->row;
        }
        return false;
    }
    
}
?>
