<?php
class Sitebill_Auth extends SiteBill {
    /**
     * Constructor
     */
    function Sitebill_Auth() {
        $this->SiteBill();
    }
    
    /**
     * Main
     */
    function main () {
        if ( $this->getConfigValue('ajax_auth_form') ) {
            if ( $_SESSION['user_id'] == '' or  $_SESSION['group'] != 'nanoadmin' ) {
                $this->riseError('not login');
                unset($_SESSION['user_id']);
            
                return $this->getAuthForm();
            }
            return true;
        } else {
        	/*
        	echo 'start check';
        	echo '<pre>';
        	print_r($_SESSION);
        	echo '</pre>';
        	*/
            if ( empty($_SESSION['user_id']) ) {
                if ( $this->checkAuth($this->getRequestValue('login'), $this->getRequestValue('password')) ) {
                    $_SESSION['user_id'] = 'true';
                    return true;
                }
                $this->riseError('not login');
                return $this->getAuthForm();
            } else {
            	require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/permission/permission.php');
            	$permission = new Permission();
            	if ( !$permission->get_access($_SESSION['user_id_value'], 'admin_panel', 'login') ) {
            		unset($_SESSION['user_id']);
            		$this->riseError('not login');
            		return $this->getAuthForm();
            	}
            }
        }
        return true;
    }
    
    /**
     * Check auth
     * @param string $login login
     * @param string $password password
     * @return boolean
     */
    function checkAuth ( $login, $password ) {
	    require_once (SITEBILL_DOCUMENT_ROOT.'/apps/system/lib/system/permission/permission.php');
	    $permission = new Permission();
	    
        $password = md5($password);
        
        $sql = "SELECT user_id, group_id FROM re_user WHERE login='$login' and password='$password'";
        
        $this->db->exec($sql);
        $this->db->fetch_assoc();
        if ( $this->db->row['user_id'] > 0 ) {
			if ( !$permission->get_access($this->db->row['user_id'], 'admin_panel', 'login') ) {
			    return false;
			}
			$session_key = md5(rand().time().$this->db->row['user_id']);
			$_SESSION['key'] = $session_key;
			$_SESSION['user_id_value']=$this->db->row['user_id'];
			$this->db->exec('SELECT system_name FROM '.DB_PREFIX.'_group WHERE group_id=(SELECT group_id FROM '.DB_PREFIX.'_user WHERE login=\''.$login.'\')');
			$this->db->fetch_assoc();
			$_SESSION['current_user_group_name']=$this->db->row['system_name'];
            return true;
        }
        return false;
    }
    
    /**
     * Check auth
     * @param string $login login
     * @param string $password password
     * @return boolean
     */
    function checkRemoteAuth ( $login, $password ) {
        $password = md5($password);
        if ( $login != '' and $password != '' ) {
            $response = file_get_contents('http://www.sitebill.ru/auth.php?login='.$login.'&password='.$password);
            $auth_status = explode(':', $response);
            //echo '<pre>';
            //print_r($auth_status);
            //echo '</pre>';
            if ( $auth_status[0] == 'error' ) {
                $this->riseError($auth_status[1]);
                return false;
            }
            if ( $auth_status[5] != 'nanoadmin' ) {
                $this->riseError('    ');
                return false;
            }
            if ( $auth_status[0] == 'success' ) {
                $_SESSION['user_id'] = $auth_status[1];
                $_SESSION['key'] = $auth_status[3];
                $_SESSION['group'] = $auth_status[5];
                //print_r($_SESSION);
                return true; 
            }
        }
        $this->riseError('not login');
        unset($_SESSION['user_id']);
        return false;
    }
    
    /**
     * Get auth form
     * @param
     * @return
     */
    function getAuthForm () {
        $rs .= '
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
	<link href="http://www.sitebill.ru/css/nano.css" rel="stylesheet" type="text/css" />
    <script src="'.SITEBILL_MAIN_URL.'/js/jquery.js"></script>
	<script src="http://www.sitebill.ru/js/nanoapi.js"></script>
	<script src="http://www.sitebill.ru/js/nanoapi_beta.js"></script>
    <link rel=stylesheet type="text/css" href="'.SITEBILL_MAIN_URL.'/css/style.css">
</head>
<body>
        <p>&nbsp;</p>        
                                    <table border="0" cellpadding="0" cellspacing="0" align="center">
                                        <tr>
                                            <td class="special">
                                            	<div id="admin_area">
                                                <h1></h1><br>
        ';
        if ( $this->isDemo() ) {
        	$rs .= 'login: admin, password: admin';
        }
        
        if ( $this->getConfigValue('ajax_auth_form') ) {
            $rs .= $this->get_ajax_auth_form();
        } else {
            $rs .= $this->get_simple_auth_form('/admin/', false, false);
        }
        $rs .= '
                                        </div>    
        								</td>
                                        </tr>
                                    </table>
</body>
</html>
        ';
        return $rs;
    }
    
    
}

$sitebill_auth = new Sitebill_Auth();
$sitebill_auth->main();
if ( $sitebill_auth->getError() ) {
    echo $sitebill_auth->getAuthForm();
    exit;
}

?>
